
/*

  KLayout Layout Viewer
  Copyright (C) 2006-2024 Matthias Koefferlein

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

/**
*  @file gsiDeclQSqlField.cc 
*
*  DO NOT EDIT THIS FILE. 
*  This file has been created automatically
*/

#include <QSqlField>
#include "gsiQt.h"
#include "gsiQtSqlCommon.h"
#include <memory>

// -----------------------------------------------------------------------
// class QSqlField

//  Constructor QSqlField::QSqlField(const QString &fieldName, QVariant::Type type)


static void _init_ctor_QSqlField_3693 (qt_gsi::GenericStaticMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("fieldName", true, "QString()");
  decl->add_arg<const QString & > (argspec_0);
  static gsi::ArgSpecBase argspec_1 ("type", true, "QVariant::Invalid");
  decl->add_arg<const qt_gsi::Converter<QVariant::Type>::target_type & > (argspec_1);
  decl->set_return_new<QSqlField> ();
}

static void _call_ctor_QSqlField_3693 (const qt_gsi::GenericStaticMethod * /*decl*/, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  const QString &arg1 = args ? gsi::arg_reader<const QString & >() (args, heap) : gsi::arg_maker<const QString & >() (QString(), heap);
  const qt_gsi::Converter<QVariant::Type>::target_type & arg2 = args ? gsi::arg_reader<const qt_gsi::Converter<QVariant::Type>::target_type & >() (args, heap) : gsi::arg_maker<const qt_gsi::Converter<QVariant::Type>::target_type & >() (qt_gsi::CppToQtReadAdaptor<QVariant::Type>(heap, QVariant::Invalid), heap);
  ret.write<QSqlField *> (new QSqlField (arg1, qt_gsi::QtToCppAdaptor<QVariant::Type>(arg2).cref()));
}


//  Constructor QSqlField::QSqlField(const QString &fieldName, QVariant::Type type, const QString &tableName)


static void _init_ctor_QSqlField_5610 (qt_gsi::GenericStaticMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("fieldName");
  decl->add_arg<const QString & > (argspec_0);
  static gsi::ArgSpecBase argspec_1 ("type");
  decl->add_arg<const qt_gsi::Converter<QVariant::Type>::target_type & > (argspec_1);
  static gsi::ArgSpecBase argspec_2 ("tableName");
  decl->add_arg<const QString & > (argspec_2);
  decl->set_return_new<QSqlField> ();
}

static void _call_ctor_QSqlField_5610 (const qt_gsi::GenericStaticMethod * /*decl*/, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  const QString &arg1 = gsi::arg_reader<const QString & >() (args, heap);
  const qt_gsi::Converter<QVariant::Type>::target_type & arg2 = gsi::arg_reader<const qt_gsi::Converter<QVariant::Type>::target_type & >() (args, heap);
  const QString &arg3 = gsi::arg_reader<const QString & >() (args, heap);
  ret.write<QSqlField *> (new QSqlField (arg1, qt_gsi::QtToCppAdaptor<QVariant::Type>(arg2).cref(), arg3));
}


//  Constructor QSqlField::QSqlField(const QSqlField &other)


static void _init_ctor_QSqlField_2182 (qt_gsi::GenericStaticMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("other");
  decl->add_arg<const QSqlField & > (argspec_0);
  decl->set_return_new<QSqlField> ();
}

static void _call_ctor_QSqlField_2182 (const qt_gsi::GenericStaticMethod * /*decl*/, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  const QSqlField &arg1 = gsi::arg_reader<const QSqlField & >() (args, heap);
  ret.write<QSqlField *> (new QSqlField (arg1));
}


// void QSqlField::clear()


static void _init_f_clear_0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<void > ();
}

static void _call_f_clear_0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QSqlField *)cls)->clear ();
}


// QVariant QSqlField::defaultValue()


static void _init_f_defaultValue_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<QVariant > ();
}

static void _call_f_defaultValue_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<QVariant > ((QVariant)((QSqlField *)cls)->defaultValue ());
}


// bool QSqlField::isAutoValue()


static void _init_f_isAutoValue_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<bool > ();
}

static void _call_f_isAutoValue_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<bool > ((bool)((QSqlField *)cls)->isAutoValue ());
}


// bool QSqlField::isGenerated()


static void _init_f_isGenerated_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<bool > ();
}

static void _call_f_isGenerated_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<bool > ((bool)((QSqlField *)cls)->isGenerated ());
}


// bool QSqlField::isNull()


static void _init_f_isNull_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<bool > ();
}

static void _call_f_isNull_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<bool > ((bool)((QSqlField *)cls)->isNull ());
}


// bool QSqlField::isReadOnly()


static void _init_f_isReadOnly_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<bool > ();
}

static void _call_f_isReadOnly_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<bool > ((bool)((QSqlField *)cls)->isReadOnly ());
}


// bool QSqlField::isValid()


static void _init_f_isValid_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<bool > ();
}

static void _call_f_isValid_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<bool > ((bool)((QSqlField *)cls)->isValid ());
}


// int QSqlField::length()


static void _init_f_length_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<int > ();
}

static void _call_f_length_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<int > ((int)((QSqlField *)cls)->length ());
}


// QString QSqlField::name()


static void _init_f_name_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<QString > ();
}

static void _call_f_name_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<QString > ((QString)((QSqlField *)cls)->name ());
}


// bool QSqlField::operator!=(const QSqlField &other)


static void _init_f_operator_excl__eq__c2182 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("other");
  decl->add_arg<const QSqlField & > (argspec_0);
  decl->set_return<bool > ();
}

static void _call_f_operator_excl__eq__c2182 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  const QSqlField &arg1 = gsi::arg_reader<const QSqlField & >() (args, heap);
  ret.write<bool > ((bool)((QSqlField *)cls)->operator!= (arg1));
}


// QSqlField &QSqlField::operator=(const QSqlField &other)


static void _init_f_operator_eq__2182 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("other");
  decl->add_arg<const QSqlField & > (argspec_0);
  decl->set_return<QSqlField & > ();
}

static void _call_f_operator_eq__2182 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  const QSqlField &arg1 = gsi::arg_reader<const QSqlField & >() (args, heap);
  ret.write<QSqlField & > ((QSqlField &)((QSqlField *)cls)->operator= (arg1));
}


// bool QSqlField::operator==(const QSqlField &other)


static void _init_f_operator_eq__eq__c2182 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("other");
  decl->add_arg<const QSqlField & > (argspec_0);
  decl->set_return<bool > ();
}

static void _call_f_operator_eq__eq__c2182 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  const QSqlField &arg1 = gsi::arg_reader<const QSqlField & >() (args, heap);
  ret.write<bool > ((bool)((QSqlField *)cls)->operator== (arg1));
}


// int QSqlField::precision()


static void _init_f_precision_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<int > ();
}

static void _call_f_precision_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<int > ((int)((QSqlField *)cls)->precision ());
}


// QSqlField::RequiredStatus QSqlField::requiredStatus()


static void _init_f_requiredStatus_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<qt_gsi::Converter<QSqlField::RequiredStatus>::target_type > ();
}

static void _call_f_requiredStatus_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<qt_gsi::Converter<QSqlField::RequiredStatus>::target_type > ((qt_gsi::Converter<QSqlField::RequiredStatus>::target_type)qt_gsi::CppToQtAdaptor<QSqlField::RequiredStatus>(((QSqlField *)cls)->requiredStatus ()));
}


// void QSqlField::setAutoValue(bool autoVal)


static void _init_f_setAutoValue_864 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("autoVal");
  decl->add_arg<bool > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setAutoValue_864 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  bool arg1 = gsi::arg_reader<bool >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QSqlField *)cls)->setAutoValue (arg1);
}


// void QSqlField::setDefaultValue(const QVariant &value)


static void _init_f_setDefaultValue_2119 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("value");
  decl->add_arg<const QVariant & > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setDefaultValue_2119 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  const QVariant &arg1 = gsi::arg_reader<const QVariant & >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QSqlField *)cls)->setDefaultValue (arg1);
}


// void QSqlField::setGenerated(bool gen)


static void _init_f_setGenerated_864 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("gen");
  decl->add_arg<bool > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setGenerated_864 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  bool arg1 = gsi::arg_reader<bool >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QSqlField *)cls)->setGenerated (arg1);
}


// void QSqlField::setLength(int fieldLength)


static void _init_f_setLength_767 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("fieldLength");
  decl->add_arg<int > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setLength_767 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  int arg1 = gsi::arg_reader<int >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QSqlField *)cls)->setLength (arg1);
}


// void QSqlField::setName(const QString &name)


static void _init_f_setName_2025 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("name");
  decl->add_arg<const QString & > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setName_2025 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  const QString &arg1 = gsi::arg_reader<const QString & >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QSqlField *)cls)->setName (arg1);
}


// void QSqlField::setPrecision(int precision)


static void _init_f_setPrecision_767 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("precision");
  decl->add_arg<int > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setPrecision_767 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  int arg1 = gsi::arg_reader<int >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QSqlField *)cls)->setPrecision (arg1);
}


// void QSqlField::setReadOnly(bool readOnly)


static void _init_f_setReadOnly_864 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("readOnly");
  decl->add_arg<bool > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setReadOnly_864 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  bool arg1 = gsi::arg_reader<bool >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QSqlField *)cls)->setReadOnly (arg1);
}


// void QSqlField::setRequired(bool required)


static void _init_f_setRequired_864 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("required");
  decl->add_arg<bool > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setRequired_864 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  bool arg1 = gsi::arg_reader<bool >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QSqlField *)cls)->setRequired (arg1);
}


// void QSqlField::setRequiredStatus(QSqlField::RequiredStatus status)


static void _init_f_setRequiredStatus_2898 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("status");
  decl->add_arg<const qt_gsi::Converter<QSqlField::RequiredStatus>::target_type & > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setRequiredStatus_2898 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  const qt_gsi::Converter<QSqlField::RequiredStatus>::target_type & arg1 = gsi::arg_reader<const qt_gsi::Converter<QSqlField::RequiredStatus>::target_type & >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QSqlField *)cls)->setRequiredStatus (qt_gsi::QtToCppAdaptor<QSqlField::RequiredStatus>(arg1).cref());
}


// void QSqlField::setSqlType(int type)


static void _init_f_setSqlType_767 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("type");
  decl->add_arg<int > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setSqlType_767 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  int arg1 = gsi::arg_reader<int >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QSqlField *)cls)->setSqlType (arg1);
}


// void QSqlField::setTableName(const QString &tableName)


static void _init_f_setTableName_2025 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("tableName");
  decl->add_arg<const QString & > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setTableName_2025 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  const QString &arg1 = gsi::arg_reader<const QString & >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QSqlField *)cls)->setTableName (arg1);
}


// void QSqlField::setType(QVariant::Type type)


static void _init_f_setType_1776 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("type");
  decl->add_arg<const qt_gsi::Converter<QVariant::Type>::target_type & > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setType_1776 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  const qt_gsi::Converter<QVariant::Type>::target_type & arg1 = gsi::arg_reader<const qt_gsi::Converter<QVariant::Type>::target_type & >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QSqlField *)cls)->setType (qt_gsi::QtToCppAdaptor<QVariant::Type>(arg1).cref());
}


// void QSqlField::setValue(const QVariant &value)


static void _init_f_setValue_2119 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("value");
  decl->add_arg<const QVariant & > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setValue_2119 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  const QVariant &arg1 = gsi::arg_reader<const QVariant & >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QSqlField *)cls)->setValue (arg1);
}


// QString QSqlField::tableName()


static void _init_f_tableName_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<QString > ();
}

static void _call_f_tableName_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<QString > ((QString)((QSqlField *)cls)->tableName ());
}


// QVariant::Type QSqlField::type()


static void _init_f_type_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<qt_gsi::Converter<QVariant::Type>::target_type > ();
}

static void _call_f_type_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<qt_gsi::Converter<QVariant::Type>::target_type > ((qt_gsi::Converter<QVariant::Type>::target_type)qt_gsi::CppToQtAdaptor<QVariant::Type>(((QSqlField *)cls)->type ()));
}


// int QSqlField::typeID()


static void _init_f_typeID_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<int > ();
}

static void _call_f_typeID_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<int > ((int)((QSqlField *)cls)->typeID ());
}


// QVariant QSqlField::value()


static void _init_f_value_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<QVariant > ();
}

static void _call_f_value_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<QVariant > ((QVariant)((QSqlField *)cls)->value ());
}



namespace gsi
{

static gsi::Methods methods_QSqlField () {
  gsi::Methods methods;
  methods += new qt_gsi::GenericStaticMethod ("new", "@brief Constructor QSqlField::QSqlField(const QString &fieldName, QVariant::Type type)\nThis method creates an object of class QSqlField.", &_init_ctor_QSqlField_3693, &_call_ctor_QSqlField_3693);
  methods += new qt_gsi::GenericStaticMethod ("new", "@brief Constructor QSqlField::QSqlField(const QString &fieldName, QVariant::Type type, const QString &tableName)\nThis method creates an object of class QSqlField.", &_init_ctor_QSqlField_5610, &_call_ctor_QSqlField_5610);
  methods += new qt_gsi::GenericStaticMethod ("new", "@brief Constructor QSqlField::QSqlField(const QSqlField &other)\nThis method creates an object of class QSqlField.", &_init_ctor_QSqlField_2182, &_call_ctor_QSqlField_2182);
  methods += new qt_gsi::GenericMethod ("clear", "@brief Method void QSqlField::clear()\n", false, &_init_f_clear_0, &_call_f_clear_0);
  methods += new qt_gsi::GenericMethod (":defaultValue", "@brief Method QVariant QSqlField::defaultValue()\n", true, &_init_f_defaultValue_c0, &_call_f_defaultValue_c0);
  methods += new qt_gsi::GenericMethod ("isAutoValue?|:autoValue", "@brief Method bool QSqlField::isAutoValue()\n", true, &_init_f_isAutoValue_c0, &_call_f_isAutoValue_c0);
  methods += new qt_gsi::GenericMethod ("isGenerated?|:generated", "@brief Method bool QSqlField::isGenerated()\n", true, &_init_f_isGenerated_c0, &_call_f_isGenerated_c0);
  methods += new qt_gsi::GenericMethod ("isNull?", "@brief Method bool QSqlField::isNull()\n", true, &_init_f_isNull_c0, &_call_f_isNull_c0);
  methods += new qt_gsi::GenericMethod ("isReadOnly?|:readOnly", "@brief Method bool QSqlField::isReadOnly()\n", true, &_init_f_isReadOnly_c0, &_call_f_isReadOnly_c0);
  methods += new qt_gsi::GenericMethod ("isValid?", "@brief Method bool QSqlField::isValid()\n", true, &_init_f_isValid_c0, &_call_f_isValid_c0);
  methods += new qt_gsi::GenericMethod (":length", "@brief Method int QSqlField::length()\n", true, &_init_f_length_c0, &_call_f_length_c0);
  methods += new qt_gsi::GenericMethod (":name", "@brief Method QString QSqlField::name()\n", true, &_init_f_name_c0, &_call_f_name_c0);
  methods += new qt_gsi::GenericMethod ("!=", "@brief Method bool QSqlField::operator!=(const QSqlField &other)\n", true, &_init_f_operator_excl__eq__c2182, &_call_f_operator_excl__eq__c2182);
  methods += new qt_gsi::GenericMethod ("assign", "@brief Method QSqlField &QSqlField::operator=(const QSqlField &other)\n", false, &_init_f_operator_eq__2182, &_call_f_operator_eq__2182);
  methods += new qt_gsi::GenericMethod ("==", "@brief Method bool QSqlField::operator==(const QSqlField &other)\n", true, &_init_f_operator_eq__eq__c2182, &_call_f_operator_eq__eq__c2182);
  methods += new qt_gsi::GenericMethod (":precision", "@brief Method int QSqlField::precision()\n", true, &_init_f_precision_c0, &_call_f_precision_c0);
  methods += new qt_gsi::GenericMethod (":requiredStatus", "@brief Method QSqlField::RequiredStatus QSqlField::requiredStatus()\n", true, &_init_f_requiredStatus_c0, &_call_f_requiredStatus_c0);
  methods += new qt_gsi::GenericMethod ("setAutoValue|autoValue=", "@brief Method void QSqlField::setAutoValue(bool autoVal)\n", false, &_init_f_setAutoValue_864, &_call_f_setAutoValue_864);
  methods += new qt_gsi::GenericMethod ("setDefaultValue|defaultValue=", "@brief Method void QSqlField::setDefaultValue(const QVariant &value)\n", false, &_init_f_setDefaultValue_2119, &_call_f_setDefaultValue_2119);
  methods += new qt_gsi::GenericMethod ("setGenerated|generated=", "@brief Method void QSqlField::setGenerated(bool gen)\n", false, &_init_f_setGenerated_864, &_call_f_setGenerated_864);
  methods += new qt_gsi::GenericMethod ("setLength|length=", "@brief Method void QSqlField::setLength(int fieldLength)\n", false, &_init_f_setLength_767, &_call_f_setLength_767);
  methods += new qt_gsi::GenericMethod ("setName|name=", "@brief Method void QSqlField::setName(const QString &name)\n", false, &_init_f_setName_2025, &_call_f_setName_2025);
  methods += new qt_gsi::GenericMethod ("setPrecision|precision=", "@brief Method void QSqlField::setPrecision(int precision)\n", false, &_init_f_setPrecision_767, &_call_f_setPrecision_767);
  methods += new qt_gsi::GenericMethod ("setReadOnly|readOnly=", "@brief Method void QSqlField::setReadOnly(bool readOnly)\n", false, &_init_f_setReadOnly_864, &_call_f_setReadOnly_864);
  methods += new qt_gsi::GenericMethod ("setRequired", "@brief Method void QSqlField::setRequired(bool required)\n", false, &_init_f_setRequired_864, &_call_f_setRequired_864);
  methods += new qt_gsi::GenericMethod ("setRequiredStatus|requiredStatus=", "@brief Method void QSqlField::setRequiredStatus(QSqlField::RequiredStatus status)\n", false, &_init_f_setRequiredStatus_2898, &_call_f_setRequiredStatus_2898);
  methods += new qt_gsi::GenericMethod ("setSqlType", "@brief Method void QSqlField::setSqlType(int type)\n", false, &_init_f_setSqlType_767, &_call_f_setSqlType_767);
  methods += new qt_gsi::GenericMethod ("setTableName|tableName=", "@brief Method void QSqlField::setTableName(const QString &tableName)\n", false, &_init_f_setTableName_2025, &_call_f_setTableName_2025);
  methods += new qt_gsi::GenericMethod ("setType|type=", "@brief Method void QSqlField::setType(QVariant::Type type)\n", false, &_init_f_setType_1776, &_call_f_setType_1776);
  methods += new qt_gsi::GenericMethod ("setValue|value=", "@brief Method void QSqlField::setValue(const QVariant &value)\n", false, &_init_f_setValue_2119, &_call_f_setValue_2119);
  methods += new qt_gsi::GenericMethod (":tableName", "@brief Method QString QSqlField::tableName()\n", true, &_init_f_tableName_c0, &_call_f_tableName_c0);
  methods += new qt_gsi::GenericMethod (":type", "@brief Method QVariant::Type QSqlField::type()\n", true, &_init_f_type_c0, &_call_f_type_c0);
  methods += new qt_gsi::GenericMethod ("typeID", "@brief Method int QSqlField::typeID()\n", true, &_init_f_typeID_c0, &_call_f_typeID_c0);
  methods += new qt_gsi::GenericMethod (":value", "@brief Method QVariant QSqlField::value()\n", true, &_init_f_value_c0, &_call_f_value_c0);
  return methods;
}

gsi::Class<QSqlField> decl_QSqlField ("QtSql", "QSqlField",
  methods_QSqlField (),
  "@qt\n@brief Binding of QSqlField");


GSI_QTSQL_PUBLIC gsi::Class<QSqlField> &qtdecl_QSqlField () { return decl_QSqlField; }

}


//  Implementation of the enum wrapper class for QSqlField::RequiredStatus
namespace qt_gsi
{

static gsi::Enum<QSqlField::RequiredStatus> decl_QSqlField_RequiredStatus_Enum ("QtSql", "QSqlField_RequiredStatus",
    gsi::enum_const ("Unknown", QSqlField::Unknown, "@brief Enum constant QSqlField::Unknown") +
    gsi::enum_const ("Optional", QSqlField::Optional, "@brief Enum constant QSqlField::Optional") +
    gsi::enum_const ("Required", QSqlField::Required, "@brief Enum constant QSqlField::Required"),
  "@qt\n@brief This class represents the QSqlField::RequiredStatus enum");

static gsi::QFlagsClass<QSqlField::RequiredStatus > decl_QSqlField_RequiredStatus_Enums ("QtSql", "QSqlField_QFlags_RequiredStatus",
  "@qt\n@brief This class represents the QFlags<QSqlField::RequiredStatus> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<QSqlField> inject_QSqlField_RequiredStatus_Enum_in_parent (decl_QSqlField_RequiredStatus_Enum.defs ());
static gsi::ClassExt<QSqlField> decl_QSqlField_RequiredStatus_Enum_as_child (decl_QSqlField_RequiredStatus_Enum, "RequiredStatus");
static gsi::ClassExt<QSqlField> decl_QSqlField_RequiredStatus_Enums_as_child (decl_QSqlField_RequiredStatus_Enums, "QFlags_RequiredStatus");

}

