
/*

  KLayout Layout Viewer
  Copyright (C) 2006-2024 Matthias Koefferlein

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

/**
*  @file gsiDeclQt_2.cc 
*
*  DO NOT EDIT THIS FILE. 
*  This file has been created automatically
*/

#include <Qt>
#include "gsiQt.h"
#include "gsiQtCoreCommon.h"
#include <memory>

// -----------------------------------------------------------------------
// namespace Qt

class Qt_Namespace { };


//  Implementation of the enum wrapper class for Qt::InputMethodQuery
namespace qt_gsi
{

static gsi::Enum<Qt::InputMethodQuery> decl_Qt_InputMethodQuery_Enum ("QtCore", "Qt_InputMethodQuery",
    gsi::enum_const ("ImEnabled", Qt::ImEnabled, "@brief Enum constant Qt::ImEnabled") +
    gsi::enum_const ("ImCursorRectangle", Qt::ImCursorRectangle, "@brief Enum constant Qt::ImCursorRectangle") +
    gsi::enum_const ("ImFont", Qt::ImFont, "@brief Enum constant Qt::ImFont") +
    gsi::enum_const ("ImCursorPosition", Qt::ImCursorPosition, "@brief Enum constant Qt::ImCursorPosition") +
    gsi::enum_const ("ImSurroundingText", Qt::ImSurroundingText, "@brief Enum constant Qt::ImSurroundingText") +
    gsi::enum_const ("ImCurrentSelection", Qt::ImCurrentSelection, "@brief Enum constant Qt::ImCurrentSelection") +
    gsi::enum_const ("ImMaximumTextLength", Qt::ImMaximumTextLength, "@brief Enum constant Qt::ImMaximumTextLength") +
    gsi::enum_const ("ImAnchorPosition", Qt::ImAnchorPosition, "@brief Enum constant Qt::ImAnchorPosition") +
    gsi::enum_const ("ImHints", Qt::ImHints, "@brief Enum constant Qt::ImHints") +
    gsi::enum_const ("ImPreferredLanguage", Qt::ImPreferredLanguage, "@brief Enum constant Qt::ImPreferredLanguage") +
    gsi::enum_const ("ImAbsolutePosition", Qt::ImAbsolutePosition, "@brief Enum constant Qt::ImAbsolutePosition") +
    gsi::enum_const ("ImTextBeforeCursor", Qt::ImTextBeforeCursor, "@brief Enum constant Qt::ImTextBeforeCursor") +
    gsi::enum_const ("ImTextAfterCursor", Qt::ImTextAfterCursor, "@brief Enum constant Qt::ImTextAfterCursor") +
    gsi::enum_const ("ImEnterKeyType", Qt::ImEnterKeyType, "@brief Enum constant Qt::ImEnterKeyType") +
    gsi::enum_const ("ImAnchorRectangle", Qt::ImAnchorRectangle, "@brief Enum constant Qt::ImAnchorRectangle") +
    gsi::enum_const ("ImInputItemClipRectangle", Qt::ImInputItemClipRectangle, "@brief Enum constant Qt::ImInputItemClipRectangle") +
    gsi::enum_const ("ImReadOnly", Qt::ImReadOnly, "@brief Enum constant Qt::ImReadOnly") +
    gsi::enum_const ("ImPlatformData", Qt::ImPlatformData, "@brief Enum constant Qt::ImPlatformData") +
    gsi::enum_const ("ImQueryInput", Qt::ImQueryInput, "@brief Enum constant Qt::ImQueryInput") +
    gsi::enum_const ("ImQueryAll", Qt::ImQueryAll, "@brief Enum constant Qt::ImQueryAll"),
  "@qt\n@brief This class represents the Qt::InputMethodQuery enum");

static gsi::QFlagsClass<Qt::InputMethodQuery > decl_Qt_InputMethodQuery_Enums ("QtCore", "Qt_QFlags_InputMethodQuery",
  "@qt\n@brief This class represents the QFlags<Qt::InputMethodQuery> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_InputMethodQuery_Enum_in_parent (decl_Qt_InputMethodQuery_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_InputMethodQuery_Enum_as_child (decl_Qt_InputMethodQuery_Enum, "InputMethodQuery");
static gsi::ClassExt<Qt_Namespace> decl_Qt_InputMethodQuery_Enums_as_child (decl_Qt_InputMethodQuery_Enums, "QFlags_InputMethodQuery");

}


//  Implementation of the enum wrapper class for Qt::ItemDataRole
namespace qt_gsi
{

static gsi::Enum<Qt::ItemDataRole> decl_Qt_ItemDataRole_Enum ("QtCore", "Qt_ItemDataRole",
    gsi::enum_const ("DisplayRole", Qt::DisplayRole, "@brief Enum constant Qt::DisplayRole") +
    gsi::enum_const ("DecorationRole", Qt::DecorationRole, "@brief Enum constant Qt::DecorationRole") +
    gsi::enum_const ("EditRole", Qt::EditRole, "@brief Enum constant Qt::EditRole") +
    gsi::enum_const ("ToolTipRole", Qt::ToolTipRole, "@brief Enum constant Qt::ToolTipRole") +
    gsi::enum_const ("StatusTipRole", Qt::StatusTipRole, "@brief Enum constant Qt::StatusTipRole") +
    gsi::enum_const ("WhatsThisRole", Qt::WhatsThisRole, "@brief Enum constant Qt::WhatsThisRole") +
    gsi::enum_const ("FontRole", Qt::FontRole, "@brief Enum constant Qt::FontRole") +
    gsi::enum_const ("TextAlignmentRole", Qt::TextAlignmentRole, "@brief Enum constant Qt::TextAlignmentRole") +
    gsi::enum_const ("BackgroundRole", Qt::BackgroundRole, "@brief Enum constant Qt::BackgroundRole") +
    gsi::enum_const ("ForegroundRole", Qt::ForegroundRole, "@brief Enum constant Qt::ForegroundRole") +
    gsi::enum_const ("CheckStateRole", Qt::CheckStateRole, "@brief Enum constant Qt::CheckStateRole") +
    gsi::enum_const ("AccessibleTextRole", Qt::AccessibleTextRole, "@brief Enum constant Qt::AccessibleTextRole") +
    gsi::enum_const ("AccessibleDescriptionRole", Qt::AccessibleDescriptionRole, "@brief Enum constant Qt::AccessibleDescriptionRole") +
    gsi::enum_const ("SizeHintRole", Qt::SizeHintRole, "@brief Enum constant Qt::SizeHintRole") +
    gsi::enum_const ("InitialSortOrderRole", Qt::InitialSortOrderRole, "@brief Enum constant Qt::InitialSortOrderRole") +
    gsi::enum_const ("DisplayPropertyRole", Qt::DisplayPropertyRole, "@brief Enum constant Qt::DisplayPropertyRole") +
    gsi::enum_const ("DecorationPropertyRole", Qt::DecorationPropertyRole, "@brief Enum constant Qt::DecorationPropertyRole") +
    gsi::enum_const ("ToolTipPropertyRole", Qt::ToolTipPropertyRole, "@brief Enum constant Qt::ToolTipPropertyRole") +
    gsi::enum_const ("StatusTipPropertyRole", Qt::StatusTipPropertyRole, "@brief Enum constant Qt::StatusTipPropertyRole") +
    gsi::enum_const ("WhatsThisPropertyRole", Qt::WhatsThisPropertyRole, "@brief Enum constant Qt::WhatsThisPropertyRole") +
    gsi::enum_const ("UserRole", Qt::UserRole, "@brief Enum constant Qt::UserRole"),
  "@qt\n@brief This class represents the Qt::ItemDataRole enum");

static gsi::QFlagsClass<Qt::ItemDataRole > decl_Qt_ItemDataRole_Enums ("QtCore", "Qt_QFlags_ItemDataRole",
  "@qt\n@brief This class represents the QFlags<Qt::ItemDataRole> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_ItemDataRole_Enum_in_parent (decl_Qt_ItemDataRole_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_ItemDataRole_Enum_as_child (decl_Qt_ItemDataRole_Enum, "ItemDataRole");
static gsi::ClassExt<Qt_Namespace> decl_Qt_ItemDataRole_Enums_as_child (decl_Qt_ItemDataRole_Enums, "QFlags_ItemDataRole");

}


//  Implementation of the enum wrapper class for Qt::ItemFlag
namespace qt_gsi
{

static gsi::Enum<Qt::ItemFlag> decl_Qt_ItemFlag_Enum ("QtCore", "Qt_ItemFlag",
    gsi::enum_const ("NoItemFlags", Qt::NoItemFlags, "@brief Enum constant Qt::NoItemFlags") +
    gsi::enum_const ("ItemIsSelectable", Qt::ItemIsSelectable, "@brief Enum constant Qt::ItemIsSelectable") +
    gsi::enum_const ("ItemIsEditable", Qt::ItemIsEditable, "@brief Enum constant Qt::ItemIsEditable") +
    gsi::enum_const ("ItemIsDragEnabled", Qt::ItemIsDragEnabled, "@brief Enum constant Qt::ItemIsDragEnabled") +
    gsi::enum_const ("ItemIsDropEnabled", Qt::ItemIsDropEnabled, "@brief Enum constant Qt::ItemIsDropEnabled") +
    gsi::enum_const ("ItemIsUserCheckable", Qt::ItemIsUserCheckable, "@brief Enum constant Qt::ItemIsUserCheckable") +
    gsi::enum_const ("ItemIsEnabled", Qt::ItemIsEnabled, "@brief Enum constant Qt::ItemIsEnabled") +
    gsi::enum_const ("ItemIsAutoTristate", Qt::ItemIsAutoTristate, "@brief Enum constant Qt::ItemIsAutoTristate") +
    gsi::enum_const ("ItemNeverHasChildren", Qt::ItemNeverHasChildren, "@brief Enum constant Qt::ItemNeverHasChildren") +
    gsi::enum_const ("ItemIsUserTristate", Qt::ItemIsUserTristate, "@brief Enum constant Qt::ItemIsUserTristate"),
  "@qt\n@brief This class represents the Qt::ItemFlag enum");

static gsi::QFlagsClass<Qt::ItemFlag > decl_Qt_ItemFlag_Enums ("QtCore", "Qt_QFlags_ItemFlag",
  "@qt\n@brief This class represents the QFlags<Qt::ItemFlag> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_ItemFlag_Enum_in_parent (decl_Qt_ItemFlag_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_ItemFlag_Enum_as_child (decl_Qt_ItemFlag_Enum, "ItemFlag");
static gsi::ClassExt<Qt_Namespace> decl_Qt_ItemFlag_Enums_as_child (decl_Qt_ItemFlag_Enums, "QFlags_ItemFlag");

}


//  Implementation of the enum wrapper class for Qt::ItemSelectionMode
namespace qt_gsi
{

static gsi::Enum<Qt::ItemSelectionMode> decl_Qt_ItemSelectionMode_Enum ("QtCore", "Qt_ItemSelectionMode",
    gsi::enum_const ("ContainsItemShape", Qt::ContainsItemShape, "@brief Enum constant Qt::ContainsItemShape") +
    gsi::enum_const ("IntersectsItemShape", Qt::IntersectsItemShape, "@brief Enum constant Qt::IntersectsItemShape") +
    gsi::enum_const ("ContainsItemBoundingRect", Qt::ContainsItemBoundingRect, "@brief Enum constant Qt::ContainsItemBoundingRect") +
    gsi::enum_const ("IntersectsItemBoundingRect", Qt::IntersectsItemBoundingRect, "@brief Enum constant Qt::IntersectsItemBoundingRect"),
  "@qt\n@brief This class represents the Qt::ItemSelectionMode enum");

static gsi::QFlagsClass<Qt::ItemSelectionMode > decl_Qt_ItemSelectionMode_Enums ("QtCore", "Qt_QFlags_ItemSelectionMode",
  "@qt\n@brief This class represents the QFlags<Qt::ItemSelectionMode> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_ItemSelectionMode_Enum_in_parent (decl_Qt_ItemSelectionMode_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_ItemSelectionMode_Enum_as_child (decl_Qt_ItemSelectionMode_Enum, "ItemSelectionMode");
static gsi::ClassExt<Qt_Namespace> decl_Qt_ItemSelectionMode_Enums_as_child (decl_Qt_ItemSelectionMode_Enums, "QFlags_ItemSelectionMode");

}


//  Implementation of the enum wrapper class for Qt::ItemSelectionOperation
namespace qt_gsi
{

static gsi::Enum<Qt::ItemSelectionOperation> decl_Qt_ItemSelectionOperation_Enum ("QtCore", "Qt_ItemSelectionOperation",
    gsi::enum_const ("ReplaceSelection", Qt::ReplaceSelection, "@brief Enum constant Qt::ReplaceSelection") +
    gsi::enum_const ("AddToSelection", Qt::AddToSelection, "@brief Enum constant Qt::AddToSelection"),
  "@qt\n@brief This class represents the Qt::ItemSelectionOperation enum");

static gsi::QFlagsClass<Qt::ItemSelectionOperation > decl_Qt_ItemSelectionOperation_Enums ("QtCore", "Qt_QFlags_ItemSelectionOperation",
  "@qt\n@brief This class represents the QFlags<Qt::ItemSelectionOperation> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_ItemSelectionOperation_Enum_in_parent (decl_Qt_ItemSelectionOperation_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_ItemSelectionOperation_Enum_as_child (decl_Qt_ItemSelectionOperation_Enum, "ItemSelectionOperation");
static gsi::ClassExt<Qt_Namespace> decl_Qt_ItemSelectionOperation_Enums_as_child (decl_Qt_ItemSelectionOperation_Enums, "QFlags_ItemSelectionOperation");

}


//  Implementation of the enum wrapper class for Qt::Key
namespace qt_gsi
{

static gsi::Enum<Qt::Key> decl_Qt_Key_Enum ("QtCore", "Qt_Key",
    gsi::enum_const ("Key_Space", Qt::Key_Space, "@brief Enum constant Qt::Key_Space") +
    gsi::enum_const ("Key_Any", Qt::Key_Any, "@brief Enum constant Qt::Key_Any") +
    gsi::enum_const ("Key_Exclam", Qt::Key_Exclam, "@brief Enum constant Qt::Key_Exclam") +
    gsi::enum_const ("Key_QuoteDbl", Qt::Key_QuoteDbl, "@brief Enum constant Qt::Key_QuoteDbl") +
    gsi::enum_const ("Key_NumberSign", Qt::Key_NumberSign, "@brief Enum constant Qt::Key_NumberSign") +
    gsi::enum_const ("Key_Dollar", Qt::Key_Dollar, "@brief Enum constant Qt::Key_Dollar") +
    gsi::enum_const ("Key_Percent", Qt::Key_Percent, "@brief Enum constant Qt::Key_Percent") +
    gsi::enum_const ("Key_Ampersand", Qt::Key_Ampersand, "@brief Enum constant Qt::Key_Ampersand") +
    gsi::enum_const ("Key_Apostrophe", Qt::Key_Apostrophe, "@brief Enum constant Qt::Key_Apostrophe") +
    gsi::enum_const ("Key_ParenLeft", Qt::Key_ParenLeft, "@brief Enum constant Qt::Key_ParenLeft") +
    gsi::enum_const ("Key_ParenRight", Qt::Key_ParenRight, "@brief Enum constant Qt::Key_ParenRight") +
    gsi::enum_const ("Key_Asterisk", Qt::Key_Asterisk, "@brief Enum constant Qt::Key_Asterisk") +
    gsi::enum_const ("Key_Plus", Qt::Key_Plus, "@brief Enum constant Qt::Key_Plus") +
    gsi::enum_const ("Key_Comma", Qt::Key_Comma, "@brief Enum constant Qt::Key_Comma") +
    gsi::enum_const ("Key_Minus", Qt::Key_Minus, "@brief Enum constant Qt::Key_Minus") +
    gsi::enum_const ("Key_Period", Qt::Key_Period, "@brief Enum constant Qt::Key_Period") +
    gsi::enum_const ("Key_Slash", Qt::Key_Slash, "@brief Enum constant Qt::Key_Slash") +
    gsi::enum_const ("Key_0", Qt::Key_0, "@brief Enum constant Qt::Key_0") +
    gsi::enum_const ("Key_1", Qt::Key_1, "@brief Enum constant Qt::Key_1") +
    gsi::enum_const ("Key_2", Qt::Key_2, "@brief Enum constant Qt::Key_2") +
    gsi::enum_const ("Key_3", Qt::Key_3, "@brief Enum constant Qt::Key_3") +
    gsi::enum_const ("Key_4", Qt::Key_4, "@brief Enum constant Qt::Key_4") +
    gsi::enum_const ("Key_5", Qt::Key_5, "@brief Enum constant Qt::Key_5") +
    gsi::enum_const ("Key_6", Qt::Key_6, "@brief Enum constant Qt::Key_6") +
    gsi::enum_const ("Key_7", Qt::Key_7, "@brief Enum constant Qt::Key_7") +
    gsi::enum_const ("Key_8", Qt::Key_8, "@brief Enum constant Qt::Key_8") +
    gsi::enum_const ("Key_9", Qt::Key_9, "@brief Enum constant Qt::Key_9") +
    gsi::enum_const ("Key_Colon", Qt::Key_Colon, "@brief Enum constant Qt::Key_Colon") +
    gsi::enum_const ("Key_Semicolon", Qt::Key_Semicolon, "@brief Enum constant Qt::Key_Semicolon") +
    gsi::enum_const ("Key_Less", Qt::Key_Less, "@brief Enum constant Qt::Key_Less") +
    gsi::enum_const ("Key_Equal", Qt::Key_Equal, "@brief Enum constant Qt::Key_Equal") +
    gsi::enum_const ("Key_Greater", Qt::Key_Greater, "@brief Enum constant Qt::Key_Greater") +
    gsi::enum_const ("Key_Question", Qt::Key_Question, "@brief Enum constant Qt::Key_Question") +
    gsi::enum_const ("Key_At", Qt::Key_At, "@brief Enum constant Qt::Key_At") +
    gsi::enum_const ("Key_A", Qt::Key_A, "@brief Enum constant Qt::Key_A") +
    gsi::enum_const ("Key_B", Qt::Key_B, "@brief Enum constant Qt::Key_B") +
    gsi::enum_const ("Key_C", Qt::Key_C, "@brief Enum constant Qt::Key_C") +
    gsi::enum_const ("Key_D", Qt::Key_D, "@brief Enum constant Qt::Key_D") +
    gsi::enum_const ("Key_E", Qt::Key_E, "@brief Enum constant Qt::Key_E") +
    gsi::enum_const ("Key_F", Qt::Key_F, "@brief Enum constant Qt::Key_F") +
    gsi::enum_const ("Key_G", Qt::Key_G, "@brief Enum constant Qt::Key_G") +
    gsi::enum_const ("Key_H", Qt::Key_H, "@brief Enum constant Qt::Key_H") +
    gsi::enum_const ("Key_I", Qt::Key_I, "@brief Enum constant Qt::Key_I") +
    gsi::enum_const ("Key_J", Qt::Key_J, "@brief Enum constant Qt::Key_J") +
    gsi::enum_const ("Key_K", Qt::Key_K, "@brief Enum constant Qt::Key_K") +
    gsi::enum_const ("Key_L", Qt::Key_L, "@brief Enum constant Qt::Key_L") +
    gsi::enum_const ("Key_M", Qt::Key_M, "@brief Enum constant Qt::Key_M") +
    gsi::enum_const ("Key_N", Qt::Key_N, "@brief Enum constant Qt::Key_N") +
    gsi::enum_const ("Key_O", Qt::Key_O, "@brief Enum constant Qt::Key_O") +
    gsi::enum_const ("Key_P", Qt::Key_P, "@brief Enum constant Qt::Key_P") +
    gsi::enum_const ("Key_Q", Qt::Key_Q, "@brief Enum constant Qt::Key_Q") +
    gsi::enum_const ("Key_R", Qt::Key_R, "@brief Enum constant Qt::Key_R") +
    gsi::enum_const ("Key_S", Qt::Key_S, "@brief Enum constant Qt::Key_S") +
    gsi::enum_const ("Key_T", Qt::Key_T, "@brief Enum constant Qt::Key_T") +
    gsi::enum_const ("Key_U", Qt::Key_U, "@brief Enum constant Qt::Key_U") +
    gsi::enum_const ("Key_V", Qt::Key_V, "@brief Enum constant Qt::Key_V") +
    gsi::enum_const ("Key_W", Qt::Key_W, "@brief Enum constant Qt::Key_W") +
    gsi::enum_const ("Key_X", Qt::Key_X, "@brief Enum constant Qt::Key_X") +
    gsi::enum_const ("Key_Y", Qt::Key_Y, "@brief Enum constant Qt::Key_Y") +
    gsi::enum_const ("Key_Z", Qt::Key_Z, "@brief Enum constant Qt::Key_Z") +
    gsi::enum_const ("Key_BracketLeft", Qt::Key_BracketLeft, "@brief Enum constant Qt::Key_BracketLeft") +
    gsi::enum_const ("Key_Backslash", Qt::Key_Backslash, "@brief Enum constant Qt::Key_Backslash") +
    gsi::enum_const ("Key_BracketRight", Qt::Key_BracketRight, "@brief Enum constant Qt::Key_BracketRight") +
    gsi::enum_const ("Key_AsciiCircum", Qt::Key_AsciiCircum, "@brief Enum constant Qt::Key_AsciiCircum") +
    gsi::enum_const ("Key_Underscore", Qt::Key_Underscore, "@brief Enum constant Qt::Key_Underscore") +
    gsi::enum_const ("Key_QuoteLeft", Qt::Key_QuoteLeft, "@brief Enum constant Qt::Key_QuoteLeft") +
    gsi::enum_const ("Key_BraceLeft", Qt::Key_BraceLeft, "@brief Enum constant Qt::Key_BraceLeft") +
    gsi::enum_const ("Key_Bar", Qt::Key_Bar, "@brief Enum constant Qt::Key_Bar") +
    gsi::enum_const ("Key_BraceRight", Qt::Key_BraceRight, "@brief Enum constant Qt::Key_BraceRight") +
    gsi::enum_const ("Key_AsciiTilde", Qt::Key_AsciiTilde, "@brief Enum constant Qt::Key_AsciiTilde") +
    gsi::enum_const ("Key_nobreakspace", Qt::Key_nobreakspace, "@brief Enum constant Qt::Key_nobreakspace") +
    gsi::enum_const ("Key_exclamdown", Qt::Key_exclamdown, "@brief Enum constant Qt::Key_exclamdown") +
    gsi::enum_const ("Key_cent", Qt::Key_cent, "@brief Enum constant Qt::Key_cent") +
    gsi::enum_const ("Key_sterling", Qt::Key_sterling, "@brief Enum constant Qt::Key_sterling") +
    gsi::enum_const ("Key_currency", Qt::Key_currency, "@brief Enum constant Qt::Key_currency") +
    gsi::enum_const ("Key_yen", Qt::Key_yen, "@brief Enum constant Qt::Key_yen") +
    gsi::enum_const ("Key_brokenbar", Qt::Key_brokenbar, "@brief Enum constant Qt::Key_brokenbar") +
    gsi::enum_const ("Key_section", Qt::Key_section, "@brief Enum constant Qt::Key_section") +
    gsi::enum_const ("Key_diaeresis", Qt::Key_diaeresis, "@brief Enum constant Qt::Key_diaeresis") +
    gsi::enum_const ("Key_copyright", Qt::Key_copyright, "@brief Enum constant Qt::Key_copyright") +
    gsi::enum_const ("Key_ordfeminine", Qt::Key_ordfeminine, "@brief Enum constant Qt::Key_ordfeminine") +
    gsi::enum_const ("Key_guillemotleft", Qt::Key_guillemotleft, "@brief Enum constant Qt::Key_guillemotleft") +
    gsi::enum_const ("Key_notsign", Qt::Key_notsign, "@brief Enum constant Qt::Key_notsign") +
    gsi::enum_const ("Key_hyphen", Qt::Key_hyphen, "@brief Enum constant Qt::Key_hyphen") +
    gsi::enum_const ("Key_registered", Qt::Key_registered, "@brief Enum constant Qt::Key_registered") +
    gsi::enum_const ("Key_macron", Qt::Key_macron, "@brief Enum constant Qt::Key_macron") +
    gsi::enum_const ("Key_degree", Qt::Key_degree, "@brief Enum constant Qt::Key_degree") +
    gsi::enum_const ("Key_plusminus", Qt::Key_plusminus, "@brief Enum constant Qt::Key_plusminus") +
    gsi::enum_const ("Key_twosuperior", Qt::Key_twosuperior, "@brief Enum constant Qt::Key_twosuperior") +
    gsi::enum_const ("Key_threesuperior", Qt::Key_threesuperior, "@brief Enum constant Qt::Key_threesuperior") +
    gsi::enum_const ("Key_acute", Qt::Key_acute, "@brief Enum constant Qt::Key_acute") +
    gsi::enum_const ("Key_mu", Qt::Key_mu, "@brief Enum constant Qt::Key_mu") +
    gsi::enum_const ("Key_paragraph", Qt::Key_paragraph, "@brief Enum constant Qt::Key_paragraph") +
    gsi::enum_const ("Key_periodcentered", Qt::Key_periodcentered, "@brief Enum constant Qt::Key_periodcentered") +
    gsi::enum_const ("Key_cedilla", Qt::Key_cedilla, "@brief Enum constant Qt::Key_cedilla") +
    gsi::enum_const ("Key_onesuperior", Qt::Key_onesuperior, "@brief Enum constant Qt::Key_onesuperior") +
    gsi::enum_const ("Key_masculine", Qt::Key_masculine, "@brief Enum constant Qt::Key_masculine") +
    gsi::enum_const ("Key_guillemotright", Qt::Key_guillemotright, "@brief Enum constant Qt::Key_guillemotright") +
    gsi::enum_const ("Key_onequarter", Qt::Key_onequarter, "@brief Enum constant Qt::Key_onequarter") +
    gsi::enum_const ("Key_onehalf", Qt::Key_onehalf, "@brief Enum constant Qt::Key_onehalf") +
    gsi::enum_const ("Key_threequarters", Qt::Key_threequarters, "@brief Enum constant Qt::Key_threequarters") +
    gsi::enum_const ("Key_questiondown", Qt::Key_questiondown, "@brief Enum constant Qt::Key_questiondown") +
    gsi::enum_const ("Key_Agrave", Qt::Key_Agrave, "@brief Enum constant Qt::Key_Agrave") +
    gsi::enum_const ("Key_Aacute", Qt::Key_Aacute, "@brief Enum constant Qt::Key_Aacute") +
    gsi::enum_const ("Key_Acircumflex", Qt::Key_Acircumflex, "@brief Enum constant Qt::Key_Acircumflex") +
    gsi::enum_const ("Key_Atilde", Qt::Key_Atilde, "@brief Enum constant Qt::Key_Atilde") +
    gsi::enum_const ("Key_Adiaeresis", Qt::Key_Adiaeresis, "@brief Enum constant Qt::Key_Adiaeresis") +
    gsi::enum_const ("Key_Aring", Qt::Key_Aring, "@brief Enum constant Qt::Key_Aring") +
    gsi::enum_const ("Key_AE", Qt::Key_AE, "@brief Enum constant Qt::Key_AE") +
    gsi::enum_const ("Key_Ccedilla", Qt::Key_Ccedilla, "@brief Enum constant Qt::Key_Ccedilla") +
    gsi::enum_const ("Key_Egrave", Qt::Key_Egrave, "@brief Enum constant Qt::Key_Egrave") +
    gsi::enum_const ("Key_Eacute", Qt::Key_Eacute, "@brief Enum constant Qt::Key_Eacute") +
    gsi::enum_const ("Key_Ecircumflex", Qt::Key_Ecircumflex, "@brief Enum constant Qt::Key_Ecircumflex") +
    gsi::enum_const ("Key_Ediaeresis", Qt::Key_Ediaeresis, "@brief Enum constant Qt::Key_Ediaeresis") +
    gsi::enum_const ("Key_Igrave", Qt::Key_Igrave, "@brief Enum constant Qt::Key_Igrave") +
    gsi::enum_const ("Key_Iacute", Qt::Key_Iacute, "@brief Enum constant Qt::Key_Iacute") +
    gsi::enum_const ("Key_Icircumflex", Qt::Key_Icircumflex, "@brief Enum constant Qt::Key_Icircumflex") +
    gsi::enum_const ("Key_Idiaeresis", Qt::Key_Idiaeresis, "@brief Enum constant Qt::Key_Idiaeresis") +
    gsi::enum_const ("Key_ETH", Qt::Key_ETH, "@brief Enum constant Qt::Key_ETH") +
    gsi::enum_const ("Key_Ntilde", Qt::Key_Ntilde, "@brief Enum constant Qt::Key_Ntilde") +
    gsi::enum_const ("Key_Ograve", Qt::Key_Ograve, "@brief Enum constant Qt::Key_Ograve") +
    gsi::enum_const ("Key_Oacute", Qt::Key_Oacute, "@brief Enum constant Qt::Key_Oacute") +
    gsi::enum_const ("Key_Ocircumflex", Qt::Key_Ocircumflex, "@brief Enum constant Qt::Key_Ocircumflex") +
    gsi::enum_const ("Key_Otilde", Qt::Key_Otilde, "@brief Enum constant Qt::Key_Otilde") +
    gsi::enum_const ("Key_Odiaeresis", Qt::Key_Odiaeresis, "@brief Enum constant Qt::Key_Odiaeresis") +
    gsi::enum_const ("Key_multiply", Qt::Key_multiply, "@brief Enum constant Qt::Key_multiply") +
    gsi::enum_const ("Key_Ooblique", Qt::Key_Ooblique, "@brief Enum constant Qt::Key_Ooblique") +
    gsi::enum_const ("Key_Ugrave", Qt::Key_Ugrave, "@brief Enum constant Qt::Key_Ugrave") +
    gsi::enum_const ("Key_Uacute", Qt::Key_Uacute, "@brief Enum constant Qt::Key_Uacute") +
    gsi::enum_const ("Key_Ucircumflex", Qt::Key_Ucircumflex, "@brief Enum constant Qt::Key_Ucircumflex") +
    gsi::enum_const ("Key_Udiaeresis", Qt::Key_Udiaeresis, "@brief Enum constant Qt::Key_Udiaeresis") +
    gsi::enum_const ("Key_Yacute", Qt::Key_Yacute, "@brief Enum constant Qt::Key_Yacute") +
    gsi::enum_const ("Key_THORN", Qt::Key_THORN, "@brief Enum constant Qt::Key_THORN") +
    gsi::enum_const ("Key_ssharp", Qt::Key_ssharp, "@brief Enum constant Qt::Key_ssharp") +
    gsi::enum_const ("Key_division", Qt::Key_division, "@brief Enum constant Qt::Key_division") +
    gsi::enum_const ("Key_ydiaeresis", Qt::Key_ydiaeresis, "@brief Enum constant Qt::Key_ydiaeresis") +
    gsi::enum_const ("Key_Escape", Qt::Key_Escape, "@brief Enum constant Qt::Key_Escape") +
    gsi::enum_const ("Key_Tab", Qt::Key_Tab, "@brief Enum constant Qt::Key_Tab") +
    gsi::enum_const ("Key_Backtab", Qt::Key_Backtab, "@brief Enum constant Qt::Key_Backtab") +
    gsi::enum_const ("Key_Backspace", Qt::Key_Backspace, "@brief Enum constant Qt::Key_Backspace") +
    gsi::enum_const ("Key_Return", Qt::Key_Return, "@brief Enum constant Qt::Key_Return") +
    gsi::enum_const ("Key_Enter", Qt::Key_Enter, "@brief Enum constant Qt::Key_Enter") +
    gsi::enum_const ("Key_Insert", Qt::Key_Insert, "@brief Enum constant Qt::Key_Insert") +
    gsi::enum_const ("Key_Delete", Qt::Key_Delete, "@brief Enum constant Qt::Key_Delete") +
    gsi::enum_const ("Key_Pause", Qt::Key_Pause, "@brief Enum constant Qt::Key_Pause") +
    gsi::enum_const ("Key_Print", Qt::Key_Print, "@brief Enum constant Qt::Key_Print") +
    gsi::enum_const ("Key_SysReq", Qt::Key_SysReq, "@brief Enum constant Qt::Key_SysReq") +
    gsi::enum_const ("Key_Clear", Qt::Key_Clear, "@brief Enum constant Qt::Key_Clear") +
    gsi::enum_const ("Key_Home", Qt::Key_Home, "@brief Enum constant Qt::Key_Home") +
    gsi::enum_const ("Key_End", Qt::Key_End, "@brief Enum constant Qt::Key_End") +
    gsi::enum_const ("Key_Left", Qt::Key_Left, "@brief Enum constant Qt::Key_Left") +
    gsi::enum_const ("Key_Up", Qt::Key_Up, "@brief Enum constant Qt::Key_Up") +
    gsi::enum_const ("Key_Right", Qt::Key_Right, "@brief Enum constant Qt::Key_Right") +
    gsi::enum_const ("Key_Down", Qt::Key_Down, "@brief Enum constant Qt::Key_Down") +
    gsi::enum_const ("Key_PageUp", Qt::Key_PageUp, "@brief Enum constant Qt::Key_PageUp") +
    gsi::enum_const ("Key_PageDown", Qt::Key_PageDown, "@brief Enum constant Qt::Key_PageDown") +
    gsi::enum_const ("Key_Shift", Qt::Key_Shift, "@brief Enum constant Qt::Key_Shift") +
    gsi::enum_const ("Key_Control", Qt::Key_Control, "@brief Enum constant Qt::Key_Control") +
    gsi::enum_const ("Key_Meta", Qt::Key_Meta, "@brief Enum constant Qt::Key_Meta") +
    gsi::enum_const ("Key_Alt", Qt::Key_Alt, "@brief Enum constant Qt::Key_Alt") +
    gsi::enum_const ("Key_CapsLock", Qt::Key_CapsLock, "@brief Enum constant Qt::Key_CapsLock") +
    gsi::enum_const ("Key_NumLock", Qt::Key_NumLock, "@brief Enum constant Qt::Key_NumLock") +
    gsi::enum_const ("Key_ScrollLock", Qt::Key_ScrollLock, "@brief Enum constant Qt::Key_ScrollLock") +
    gsi::enum_const ("Key_F1", Qt::Key_F1, "@brief Enum constant Qt::Key_F1") +
    gsi::enum_const ("Key_F2", Qt::Key_F2, "@brief Enum constant Qt::Key_F2") +
    gsi::enum_const ("Key_F3", Qt::Key_F3, "@brief Enum constant Qt::Key_F3") +
    gsi::enum_const ("Key_F4", Qt::Key_F4, "@brief Enum constant Qt::Key_F4") +
    gsi::enum_const ("Key_F5", Qt::Key_F5, "@brief Enum constant Qt::Key_F5") +
    gsi::enum_const ("Key_F6", Qt::Key_F6, "@brief Enum constant Qt::Key_F6") +
    gsi::enum_const ("Key_F7", Qt::Key_F7, "@brief Enum constant Qt::Key_F7") +
    gsi::enum_const ("Key_F8", Qt::Key_F8, "@brief Enum constant Qt::Key_F8") +
    gsi::enum_const ("Key_F9", Qt::Key_F9, "@brief Enum constant Qt::Key_F9") +
    gsi::enum_const ("Key_F10", Qt::Key_F10, "@brief Enum constant Qt::Key_F10") +
    gsi::enum_const ("Key_F11", Qt::Key_F11, "@brief Enum constant Qt::Key_F11") +
    gsi::enum_const ("Key_F12", Qt::Key_F12, "@brief Enum constant Qt::Key_F12") +
    gsi::enum_const ("Key_F13", Qt::Key_F13, "@brief Enum constant Qt::Key_F13") +
    gsi::enum_const ("Key_F14", Qt::Key_F14, "@brief Enum constant Qt::Key_F14") +
    gsi::enum_const ("Key_F15", Qt::Key_F15, "@brief Enum constant Qt::Key_F15") +
    gsi::enum_const ("Key_F16", Qt::Key_F16, "@brief Enum constant Qt::Key_F16") +
    gsi::enum_const ("Key_F17", Qt::Key_F17, "@brief Enum constant Qt::Key_F17") +
    gsi::enum_const ("Key_F18", Qt::Key_F18, "@brief Enum constant Qt::Key_F18") +
    gsi::enum_const ("Key_F19", Qt::Key_F19, "@brief Enum constant Qt::Key_F19") +
    gsi::enum_const ("Key_F20", Qt::Key_F20, "@brief Enum constant Qt::Key_F20") +
    gsi::enum_const ("Key_F21", Qt::Key_F21, "@brief Enum constant Qt::Key_F21") +
    gsi::enum_const ("Key_F22", Qt::Key_F22, "@brief Enum constant Qt::Key_F22") +
    gsi::enum_const ("Key_F23", Qt::Key_F23, "@brief Enum constant Qt::Key_F23") +
    gsi::enum_const ("Key_F24", Qt::Key_F24, "@brief Enum constant Qt::Key_F24") +
    gsi::enum_const ("Key_F25", Qt::Key_F25, "@brief Enum constant Qt::Key_F25") +
    gsi::enum_const ("Key_F26", Qt::Key_F26, "@brief Enum constant Qt::Key_F26") +
    gsi::enum_const ("Key_F27", Qt::Key_F27, "@brief Enum constant Qt::Key_F27") +
    gsi::enum_const ("Key_F28", Qt::Key_F28, "@brief Enum constant Qt::Key_F28") +
    gsi::enum_const ("Key_F29", Qt::Key_F29, "@brief Enum constant Qt::Key_F29") +
    gsi::enum_const ("Key_F30", Qt::Key_F30, "@brief Enum constant Qt::Key_F30") +
    gsi::enum_const ("Key_F31", Qt::Key_F31, "@brief Enum constant Qt::Key_F31") +
    gsi::enum_const ("Key_F32", Qt::Key_F32, "@brief Enum constant Qt::Key_F32") +
    gsi::enum_const ("Key_F33", Qt::Key_F33, "@brief Enum constant Qt::Key_F33") +
    gsi::enum_const ("Key_F34", Qt::Key_F34, "@brief Enum constant Qt::Key_F34") +
    gsi::enum_const ("Key_F35", Qt::Key_F35, "@brief Enum constant Qt::Key_F35") +
    gsi::enum_const ("Key_Super_L", Qt::Key_Super_L, "@brief Enum constant Qt::Key_Super_L") +
    gsi::enum_const ("Key_Super_R", Qt::Key_Super_R, "@brief Enum constant Qt::Key_Super_R") +
    gsi::enum_const ("Key_Menu", Qt::Key_Menu, "@brief Enum constant Qt::Key_Menu") +
    gsi::enum_const ("Key_Hyper_L", Qt::Key_Hyper_L, "@brief Enum constant Qt::Key_Hyper_L") +
    gsi::enum_const ("Key_Hyper_R", Qt::Key_Hyper_R, "@brief Enum constant Qt::Key_Hyper_R") +
    gsi::enum_const ("Key_Help", Qt::Key_Help, "@brief Enum constant Qt::Key_Help") +
    gsi::enum_const ("Key_Direction_L", Qt::Key_Direction_L, "@brief Enum constant Qt::Key_Direction_L") +
    gsi::enum_const ("Key_Direction_R", Qt::Key_Direction_R, "@brief Enum constant Qt::Key_Direction_R") +
    gsi::enum_const ("Key_AltGr", Qt::Key_AltGr, "@brief Enum constant Qt::Key_AltGr") +
    gsi::enum_const ("Key_Multi_key", Qt::Key_Multi_key, "@brief Enum constant Qt::Key_Multi_key") +
    gsi::enum_const ("Key_Codeinput", Qt::Key_Codeinput, "@brief Enum constant Qt::Key_Codeinput") +
    gsi::enum_const ("Key_SingleCandidate", Qt::Key_SingleCandidate, "@brief Enum constant Qt::Key_SingleCandidate") +
    gsi::enum_const ("Key_MultipleCandidate", Qt::Key_MultipleCandidate, "@brief Enum constant Qt::Key_MultipleCandidate") +
    gsi::enum_const ("Key_PreviousCandidate", Qt::Key_PreviousCandidate, "@brief Enum constant Qt::Key_PreviousCandidate") +
    gsi::enum_const ("Key_Mode_switch", Qt::Key_Mode_switch, "@brief Enum constant Qt::Key_Mode_switch") +
    gsi::enum_const ("Key_Kanji", Qt::Key_Kanji, "@brief Enum constant Qt::Key_Kanji") +
    gsi::enum_const ("Key_Muhenkan", Qt::Key_Muhenkan, "@brief Enum constant Qt::Key_Muhenkan") +
    gsi::enum_const ("Key_Henkan", Qt::Key_Henkan, "@brief Enum constant Qt::Key_Henkan") +
    gsi::enum_const ("Key_Romaji", Qt::Key_Romaji, "@brief Enum constant Qt::Key_Romaji") +
    gsi::enum_const ("Key_Hiragana", Qt::Key_Hiragana, "@brief Enum constant Qt::Key_Hiragana") +
    gsi::enum_const ("Key_Katakana", Qt::Key_Katakana, "@brief Enum constant Qt::Key_Katakana") +
    gsi::enum_const ("Key_Hiragana_Katakana", Qt::Key_Hiragana_Katakana, "@brief Enum constant Qt::Key_Hiragana_Katakana") +
    gsi::enum_const ("Key_Zenkaku", Qt::Key_Zenkaku, "@brief Enum constant Qt::Key_Zenkaku") +
    gsi::enum_const ("Key_Hankaku", Qt::Key_Hankaku, "@brief Enum constant Qt::Key_Hankaku") +
    gsi::enum_const ("Key_Zenkaku_Hankaku", Qt::Key_Zenkaku_Hankaku, "@brief Enum constant Qt::Key_Zenkaku_Hankaku") +
    gsi::enum_const ("Key_Touroku", Qt::Key_Touroku, "@brief Enum constant Qt::Key_Touroku") +
    gsi::enum_const ("Key_Massyo", Qt::Key_Massyo, "@brief Enum constant Qt::Key_Massyo") +
    gsi::enum_const ("Key_Kana_Lock", Qt::Key_Kana_Lock, "@brief Enum constant Qt::Key_Kana_Lock") +
    gsi::enum_const ("Key_Kana_Shift", Qt::Key_Kana_Shift, "@brief Enum constant Qt::Key_Kana_Shift") +
    gsi::enum_const ("Key_Eisu_Shift", Qt::Key_Eisu_Shift, "@brief Enum constant Qt::Key_Eisu_Shift") +
    gsi::enum_const ("Key_Eisu_toggle", Qt::Key_Eisu_toggle, "@brief Enum constant Qt::Key_Eisu_toggle") +
    gsi::enum_const ("Key_Hangul", Qt::Key_Hangul, "@brief Enum constant Qt::Key_Hangul") +
    gsi::enum_const ("Key_Hangul_Start", Qt::Key_Hangul_Start, "@brief Enum constant Qt::Key_Hangul_Start") +
    gsi::enum_const ("Key_Hangul_End", Qt::Key_Hangul_End, "@brief Enum constant Qt::Key_Hangul_End") +
    gsi::enum_const ("Key_Hangul_Hanja", Qt::Key_Hangul_Hanja, "@brief Enum constant Qt::Key_Hangul_Hanja") +
    gsi::enum_const ("Key_Hangul_Jamo", Qt::Key_Hangul_Jamo, "@brief Enum constant Qt::Key_Hangul_Jamo") +
    gsi::enum_const ("Key_Hangul_Romaja", Qt::Key_Hangul_Romaja, "@brief Enum constant Qt::Key_Hangul_Romaja") +
    gsi::enum_const ("Key_Hangul_Jeonja", Qt::Key_Hangul_Jeonja, "@brief Enum constant Qt::Key_Hangul_Jeonja") +
    gsi::enum_const ("Key_Hangul_Banja", Qt::Key_Hangul_Banja, "@brief Enum constant Qt::Key_Hangul_Banja") +
    gsi::enum_const ("Key_Hangul_PreHanja", Qt::Key_Hangul_PreHanja, "@brief Enum constant Qt::Key_Hangul_PreHanja") +
    gsi::enum_const ("Key_Hangul_PostHanja", Qt::Key_Hangul_PostHanja, "@brief Enum constant Qt::Key_Hangul_PostHanja") +
    gsi::enum_const ("Key_Hangul_Special", Qt::Key_Hangul_Special, "@brief Enum constant Qt::Key_Hangul_Special") +
    gsi::enum_const ("Key_Dead_Grave", Qt::Key_Dead_Grave, "@brief Enum constant Qt::Key_Dead_Grave") +
    gsi::enum_const ("Key_Dead_Acute", Qt::Key_Dead_Acute, "@brief Enum constant Qt::Key_Dead_Acute") +
    gsi::enum_const ("Key_Dead_Circumflex", Qt::Key_Dead_Circumflex, "@brief Enum constant Qt::Key_Dead_Circumflex") +
    gsi::enum_const ("Key_Dead_Tilde", Qt::Key_Dead_Tilde, "@brief Enum constant Qt::Key_Dead_Tilde") +
    gsi::enum_const ("Key_Dead_Macron", Qt::Key_Dead_Macron, "@brief Enum constant Qt::Key_Dead_Macron") +
    gsi::enum_const ("Key_Dead_Breve", Qt::Key_Dead_Breve, "@brief Enum constant Qt::Key_Dead_Breve") +
    gsi::enum_const ("Key_Dead_Abovedot", Qt::Key_Dead_Abovedot, "@brief Enum constant Qt::Key_Dead_Abovedot") +
    gsi::enum_const ("Key_Dead_Diaeresis", Qt::Key_Dead_Diaeresis, "@brief Enum constant Qt::Key_Dead_Diaeresis") +
    gsi::enum_const ("Key_Dead_Abovering", Qt::Key_Dead_Abovering, "@brief Enum constant Qt::Key_Dead_Abovering") +
    gsi::enum_const ("Key_Dead_Doubleacute", Qt::Key_Dead_Doubleacute, "@brief Enum constant Qt::Key_Dead_Doubleacute") +
    gsi::enum_const ("Key_Dead_Caron", Qt::Key_Dead_Caron, "@brief Enum constant Qt::Key_Dead_Caron") +
    gsi::enum_const ("Key_Dead_Cedilla", Qt::Key_Dead_Cedilla, "@brief Enum constant Qt::Key_Dead_Cedilla") +
    gsi::enum_const ("Key_Dead_Ogonek", Qt::Key_Dead_Ogonek, "@brief Enum constant Qt::Key_Dead_Ogonek") +
    gsi::enum_const ("Key_Dead_Iota", Qt::Key_Dead_Iota, "@brief Enum constant Qt::Key_Dead_Iota") +
    gsi::enum_const ("Key_Dead_Voiced_Sound", Qt::Key_Dead_Voiced_Sound, "@brief Enum constant Qt::Key_Dead_Voiced_Sound") +
    gsi::enum_const ("Key_Dead_Semivoiced_Sound", Qt::Key_Dead_Semivoiced_Sound, "@brief Enum constant Qt::Key_Dead_Semivoiced_Sound") +
    gsi::enum_const ("Key_Dead_Belowdot", Qt::Key_Dead_Belowdot, "@brief Enum constant Qt::Key_Dead_Belowdot") +
    gsi::enum_const ("Key_Dead_Hook", Qt::Key_Dead_Hook, "@brief Enum constant Qt::Key_Dead_Hook") +
    gsi::enum_const ("Key_Dead_Horn", Qt::Key_Dead_Horn, "@brief Enum constant Qt::Key_Dead_Horn") +
    gsi::enum_const ("Key_Dead_Stroke", Qt::Key_Dead_Stroke, "@brief Enum constant Qt::Key_Dead_Stroke") +
    gsi::enum_const ("Key_Dead_Abovecomma", Qt::Key_Dead_Abovecomma, "@brief Enum constant Qt::Key_Dead_Abovecomma") +
    gsi::enum_const ("Key_Dead_Abovereversedcomma", Qt::Key_Dead_Abovereversedcomma, "@brief Enum constant Qt::Key_Dead_Abovereversedcomma") +
    gsi::enum_const ("Key_Dead_Doublegrave", Qt::Key_Dead_Doublegrave, "@brief Enum constant Qt::Key_Dead_Doublegrave") +
    gsi::enum_const ("Key_Dead_Belowring", Qt::Key_Dead_Belowring, "@brief Enum constant Qt::Key_Dead_Belowring") +
    gsi::enum_const ("Key_Dead_Belowmacron", Qt::Key_Dead_Belowmacron, "@brief Enum constant Qt::Key_Dead_Belowmacron") +
    gsi::enum_const ("Key_Dead_Belowcircumflex", Qt::Key_Dead_Belowcircumflex, "@brief Enum constant Qt::Key_Dead_Belowcircumflex") +
    gsi::enum_const ("Key_Dead_Belowtilde", Qt::Key_Dead_Belowtilde, "@brief Enum constant Qt::Key_Dead_Belowtilde") +
    gsi::enum_const ("Key_Dead_Belowbreve", Qt::Key_Dead_Belowbreve, "@brief Enum constant Qt::Key_Dead_Belowbreve") +
    gsi::enum_const ("Key_Dead_Belowdiaeresis", Qt::Key_Dead_Belowdiaeresis, "@brief Enum constant Qt::Key_Dead_Belowdiaeresis") +
    gsi::enum_const ("Key_Dead_Invertedbreve", Qt::Key_Dead_Invertedbreve, "@brief Enum constant Qt::Key_Dead_Invertedbreve") +
    gsi::enum_const ("Key_Dead_Belowcomma", Qt::Key_Dead_Belowcomma, "@brief Enum constant Qt::Key_Dead_Belowcomma") +
    gsi::enum_const ("Key_Dead_Currency", Qt::Key_Dead_Currency, "@brief Enum constant Qt::Key_Dead_Currency") +
    gsi::enum_const ("Key_Dead_a", Qt::Key_Dead_a, "@brief Enum constant Qt::Key_Dead_a") +
    gsi::enum_const ("Key_Dead_A", Qt::Key_Dead_A, "@brief Enum constant Qt::Key_Dead_A") +
    gsi::enum_const ("Key_Dead_e", Qt::Key_Dead_e, "@brief Enum constant Qt::Key_Dead_e") +
    gsi::enum_const ("Key_Dead_E", Qt::Key_Dead_E, "@brief Enum constant Qt::Key_Dead_E") +
    gsi::enum_const ("Key_Dead_i", Qt::Key_Dead_i, "@brief Enum constant Qt::Key_Dead_i") +
    gsi::enum_const ("Key_Dead_I", Qt::Key_Dead_I, "@brief Enum constant Qt::Key_Dead_I") +
    gsi::enum_const ("Key_Dead_o", Qt::Key_Dead_o, "@brief Enum constant Qt::Key_Dead_o") +
    gsi::enum_const ("Key_Dead_O", Qt::Key_Dead_O, "@brief Enum constant Qt::Key_Dead_O") +
    gsi::enum_const ("Key_Dead_u", Qt::Key_Dead_u, "@brief Enum constant Qt::Key_Dead_u") +
    gsi::enum_const ("Key_Dead_U", Qt::Key_Dead_U, "@brief Enum constant Qt::Key_Dead_U") +
    gsi::enum_const ("Key_Dead_Small_Schwa", Qt::Key_Dead_Small_Schwa, "@brief Enum constant Qt::Key_Dead_Small_Schwa") +
    gsi::enum_const ("Key_Dead_Capital_Schwa", Qt::Key_Dead_Capital_Schwa, "@brief Enum constant Qt::Key_Dead_Capital_Schwa") +
    gsi::enum_const ("Key_Dead_Greek", Qt::Key_Dead_Greek, "@brief Enum constant Qt::Key_Dead_Greek") +
    gsi::enum_const ("Key_Dead_Lowline", Qt::Key_Dead_Lowline, "@brief Enum constant Qt::Key_Dead_Lowline") +
    gsi::enum_const ("Key_Dead_Aboveverticalline", Qt::Key_Dead_Aboveverticalline, "@brief Enum constant Qt::Key_Dead_Aboveverticalline") +
    gsi::enum_const ("Key_Dead_Belowverticalline", Qt::Key_Dead_Belowverticalline, "@brief Enum constant Qt::Key_Dead_Belowverticalline") +
    gsi::enum_const ("Key_Dead_Longsolidusoverlay", Qt::Key_Dead_Longsolidusoverlay, "@brief Enum constant Qt::Key_Dead_Longsolidusoverlay") +
    gsi::enum_const ("Key_Back", Qt::Key_Back, "@brief Enum constant Qt::Key_Back") +
    gsi::enum_const ("Key_Forward", Qt::Key_Forward, "@brief Enum constant Qt::Key_Forward") +
    gsi::enum_const ("Key_Stop", Qt::Key_Stop, "@brief Enum constant Qt::Key_Stop") +
    gsi::enum_const ("Key_Refresh", Qt::Key_Refresh, "@brief Enum constant Qt::Key_Refresh") +
    gsi::enum_const ("Key_VolumeDown", Qt::Key_VolumeDown, "@brief Enum constant Qt::Key_VolumeDown") +
    gsi::enum_const ("Key_VolumeMute", Qt::Key_VolumeMute, "@brief Enum constant Qt::Key_VolumeMute") +
    gsi::enum_const ("Key_VolumeUp", Qt::Key_VolumeUp, "@brief Enum constant Qt::Key_VolumeUp") +
    gsi::enum_const ("Key_BassBoost", Qt::Key_BassBoost, "@brief Enum constant Qt::Key_BassBoost") +
    gsi::enum_const ("Key_BassUp", Qt::Key_BassUp, "@brief Enum constant Qt::Key_BassUp") +
    gsi::enum_const ("Key_BassDown", Qt::Key_BassDown, "@brief Enum constant Qt::Key_BassDown") +
    gsi::enum_const ("Key_TrebleUp", Qt::Key_TrebleUp, "@brief Enum constant Qt::Key_TrebleUp") +
    gsi::enum_const ("Key_TrebleDown", Qt::Key_TrebleDown, "@brief Enum constant Qt::Key_TrebleDown") +
    gsi::enum_const ("Key_MediaPlay", Qt::Key_MediaPlay, "@brief Enum constant Qt::Key_MediaPlay") +
    gsi::enum_const ("Key_MediaStop", Qt::Key_MediaStop, "@brief Enum constant Qt::Key_MediaStop") +
    gsi::enum_const ("Key_MediaPrevious", Qt::Key_MediaPrevious, "@brief Enum constant Qt::Key_MediaPrevious") +
    gsi::enum_const ("Key_MediaNext", Qt::Key_MediaNext, "@brief Enum constant Qt::Key_MediaNext") +
    gsi::enum_const ("Key_MediaRecord", Qt::Key_MediaRecord, "@brief Enum constant Qt::Key_MediaRecord") +
    gsi::enum_const ("Key_MediaPause", Qt::Key_MediaPause, "@brief Enum constant Qt::Key_MediaPause") +
    gsi::enum_const ("Key_MediaTogglePlayPause", Qt::Key_MediaTogglePlayPause, "@brief Enum constant Qt::Key_MediaTogglePlayPause") +
    gsi::enum_const ("Key_HomePage", Qt::Key_HomePage, "@brief Enum constant Qt::Key_HomePage") +
    gsi::enum_const ("Key_Favorites", Qt::Key_Favorites, "@brief Enum constant Qt::Key_Favorites") +
    gsi::enum_const ("Key_Search", Qt::Key_Search, "@brief Enum constant Qt::Key_Search") +
    gsi::enum_const ("Key_Standby", Qt::Key_Standby, "@brief Enum constant Qt::Key_Standby") +
    gsi::enum_const ("Key_OpenUrl", Qt::Key_OpenUrl, "@brief Enum constant Qt::Key_OpenUrl") +
    gsi::enum_const ("Key_LaunchMail", Qt::Key_LaunchMail, "@brief Enum constant Qt::Key_LaunchMail") +
    gsi::enum_const ("Key_LaunchMedia", Qt::Key_LaunchMedia, "@brief Enum constant Qt::Key_LaunchMedia") +
    gsi::enum_const ("Key_Launch0", Qt::Key_Launch0, "@brief Enum constant Qt::Key_Launch0") +
    gsi::enum_const ("Key_Launch1", Qt::Key_Launch1, "@brief Enum constant Qt::Key_Launch1") +
    gsi::enum_const ("Key_Launch2", Qt::Key_Launch2, "@brief Enum constant Qt::Key_Launch2") +
    gsi::enum_const ("Key_Launch3", Qt::Key_Launch3, "@brief Enum constant Qt::Key_Launch3") +
    gsi::enum_const ("Key_Launch4", Qt::Key_Launch4, "@brief Enum constant Qt::Key_Launch4") +
    gsi::enum_const ("Key_Launch5", Qt::Key_Launch5, "@brief Enum constant Qt::Key_Launch5") +
    gsi::enum_const ("Key_Launch6", Qt::Key_Launch6, "@brief Enum constant Qt::Key_Launch6") +
    gsi::enum_const ("Key_Launch7", Qt::Key_Launch7, "@brief Enum constant Qt::Key_Launch7") +
    gsi::enum_const ("Key_Launch8", Qt::Key_Launch8, "@brief Enum constant Qt::Key_Launch8") +
    gsi::enum_const ("Key_Launch9", Qt::Key_Launch9, "@brief Enum constant Qt::Key_Launch9") +
    gsi::enum_const ("Key_LaunchA", Qt::Key_LaunchA, "@brief Enum constant Qt::Key_LaunchA") +
    gsi::enum_const ("Key_LaunchB", Qt::Key_LaunchB, "@brief Enum constant Qt::Key_LaunchB") +
    gsi::enum_const ("Key_LaunchC", Qt::Key_LaunchC, "@brief Enum constant Qt::Key_LaunchC") +
    gsi::enum_const ("Key_LaunchD", Qt::Key_LaunchD, "@brief Enum constant Qt::Key_LaunchD") +
    gsi::enum_const ("Key_LaunchE", Qt::Key_LaunchE, "@brief Enum constant Qt::Key_LaunchE") +
    gsi::enum_const ("Key_LaunchF", Qt::Key_LaunchF, "@brief Enum constant Qt::Key_LaunchF") +
    gsi::enum_const ("Key_MonBrightnessUp", Qt::Key_MonBrightnessUp, "@brief Enum constant Qt::Key_MonBrightnessUp") +
    gsi::enum_const ("Key_MonBrightnessDown", Qt::Key_MonBrightnessDown, "@brief Enum constant Qt::Key_MonBrightnessDown") +
    gsi::enum_const ("Key_KeyboardLightOnOff", Qt::Key_KeyboardLightOnOff, "@brief Enum constant Qt::Key_KeyboardLightOnOff") +
    gsi::enum_const ("Key_KeyboardBrightnessUp", Qt::Key_KeyboardBrightnessUp, "@brief Enum constant Qt::Key_KeyboardBrightnessUp") +
    gsi::enum_const ("Key_KeyboardBrightnessDown", Qt::Key_KeyboardBrightnessDown, "@brief Enum constant Qt::Key_KeyboardBrightnessDown") +
    gsi::enum_const ("Key_PowerOff", Qt::Key_PowerOff, "@brief Enum constant Qt::Key_PowerOff") +
    gsi::enum_const ("Key_WakeUp", Qt::Key_WakeUp, "@brief Enum constant Qt::Key_WakeUp") +
    gsi::enum_const ("Key_Eject", Qt::Key_Eject, "@brief Enum constant Qt::Key_Eject") +
    gsi::enum_const ("Key_ScreenSaver", Qt::Key_ScreenSaver, "@brief Enum constant Qt::Key_ScreenSaver") +
    gsi::enum_const ("Key_WWW", Qt::Key_WWW, "@brief Enum constant Qt::Key_WWW") +
    gsi::enum_const ("Key_Memo", Qt::Key_Memo, "@brief Enum constant Qt::Key_Memo") +
    gsi::enum_const ("Key_LightBulb", Qt::Key_LightBulb, "@brief Enum constant Qt::Key_LightBulb") +
    gsi::enum_const ("Key_Shop", Qt::Key_Shop, "@brief Enum constant Qt::Key_Shop") +
    gsi::enum_const ("Key_History", Qt::Key_History, "@brief Enum constant Qt::Key_History") +
    gsi::enum_const ("Key_AddFavorite", Qt::Key_AddFavorite, "@brief Enum constant Qt::Key_AddFavorite") +
    gsi::enum_const ("Key_HotLinks", Qt::Key_HotLinks, "@brief Enum constant Qt::Key_HotLinks") +
    gsi::enum_const ("Key_BrightnessAdjust", Qt::Key_BrightnessAdjust, "@brief Enum constant Qt::Key_BrightnessAdjust") +
    gsi::enum_const ("Key_Finance", Qt::Key_Finance, "@brief Enum constant Qt::Key_Finance") +
    gsi::enum_const ("Key_Community", Qt::Key_Community, "@brief Enum constant Qt::Key_Community") +
    gsi::enum_const ("Key_AudioRewind", Qt::Key_AudioRewind, "@brief Enum constant Qt::Key_AudioRewind") +
    gsi::enum_const ("Key_BackForward", Qt::Key_BackForward, "@brief Enum constant Qt::Key_BackForward") +
    gsi::enum_const ("Key_ApplicationLeft", Qt::Key_ApplicationLeft, "@brief Enum constant Qt::Key_ApplicationLeft") +
    gsi::enum_const ("Key_ApplicationRight", Qt::Key_ApplicationRight, "@brief Enum constant Qt::Key_ApplicationRight") +
    gsi::enum_const ("Key_Book", Qt::Key_Book, "@brief Enum constant Qt::Key_Book") +
    gsi::enum_const ("Key_CD", Qt::Key_CD, "@brief Enum constant Qt::Key_CD") +
    gsi::enum_const ("Key_Calculator", Qt::Key_Calculator, "@brief Enum constant Qt::Key_Calculator") +
    gsi::enum_const ("Key_ToDoList", Qt::Key_ToDoList, "@brief Enum constant Qt::Key_ToDoList") +
    gsi::enum_const ("Key_ClearGrab", Qt::Key_ClearGrab, "@brief Enum constant Qt::Key_ClearGrab") +
    gsi::enum_const ("Key_Close", Qt::Key_Close, "@brief Enum constant Qt::Key_Close") +
    gsi::enum_const ("Key_Copy", Qt::Key_Copy, "@brief Enum constant Qt::Key_Copy") +
    gsi::enum_const ("Key_Cut", Qt::Key_Cut, "@brief Enum constant Qt::Key_Cut") +
    gsi::enum_const ("Key_Display", Qt::Key_Display, "@brief Enum constant Qt::Key_Display") +
    gsi::enum_const ("Key_DOS", Qt::Key_DOS, "@brief Enum constant Qt::Key_DOS") +
    gsi::enum_const ("Key_Documents", Qt::Key_Documents, "@brief Enum constant Qt::Key_Documents") +
    gsi::enum_const ("Key_Excel", Qt::Key_Excel, "@brief Enum constant Qt::Key_Excel") +
    gsi::enum_const ("Key_Explorer", Qt::Key_Explorer, "@brief Enum constant Qt::Key_Explorer") +
    gsi::enum_const ("Key_Game", Qt::Key_Game, "@brief Enum constant Qt::Key_Game") +
    gsi::enum_const ("Key_Go", Qt::Key_Go, "@brief Enum constant Qt::Key_Go") +
    gsi::enum_const ("Key_iTouch", Qt::Key_iTouch, "@brief Enum constant Qt::Key_iTouch") +
    gsi::enum_const ("Key_LogOff", Qt::Key_LogOff, "@brief Enum constant Qt::Key_LogOff") +
    gsi::enum_const ("Key_Market", Qt::Key_Market, "@brief Enum constant Qt::Key_Market") +
    gsi::enum_const ("Key_Meeting", Qt::Key_Meeting, "@brief Enum constant Qt::Key_Meeting") +
    gsi::enum_const ("Key_MenuKB", Qt::Key_MenuKB, "@brief Enum constant Qt::Key_MenuKB") +
    gsi::enum_const ("Key_MenuPB", Qt::Key_MenuPB, "@brief Enum constant Qt::Key_MenuPB") +
    gsi::enum_const ("Key_MySites", Qt::Key_MySites, "@brief Enum constant Qt::Key_MySites") +
    gsi::enum_const ("Key_News", Qt::Key_News, "@brief Enum constant Qt::Key_News") +
    gsi::enum_const ("Key_OfficeHome", Qt::Key_OfficeHome, "@brief Enum constant Qt::Key_OfficeHome") +
    gsi::enum_const ("Key_Option", Qt::Key_Option, "@brief Enum constant Qt::Key_Option") +
    gsi::enum_const ("Key_Paste", Qt::Key_Paste, "@brief Enum constant Qt::Key_Paste") +
    gsi::enum_const ("Key_Phone", Qt::Key_Phone, "@brief Enum constant Qt::Key_Phone") +
    gsi::enum_const ("Key_Calendar", Qt::Key_Calendar, "@brief Enum constant Qt::Key_Calendar") +
    gsi::enum_const ("Key_Reply", Qt::Key_Reply, "@brief Enum constant Qt::Key_Reply") +
    gsi::enum_const ("Key_Reload", Qt::Key_Reload, "@brief Enum constant Qt::Key_Reload") +
    gsi::enum_const ("Key_RotateWindows", Qt::Key_RotateWindows, "@brief Enum constant Qt::Key_RotateWindows") +
    gsi::enum_const ("Key_RotationPB", Qt::Key_RotationPB, "@brief Enum constant Qt::Key_RotationPB") +
    gsi::enum_const ("Key_RotationKB", Qt::Key_RotationKB, "@brief Enum constant Qt::Key_RotationKB") +
    gsi::enum_const ("Key_Save", Qt::Key_Save, "@brief Enum constant Qt::Key_Save") +
    gsi::enum_const ("Key_Send", Qt::Key_Send, "@brief Enum constant Qt::Key_Send") +
    gsi::enum_const ("Key_Spell", Qt::Key_Spell, "@brief Enum constant Qt::Key_Spell") +
    gsi::enum_const ("Key_SplitScreen", Qt::Key_SplitScreen, "@brief Enum constant Qt::Key_SplitScreen") +
    gsi::enum_const ("Key_Support", Qt::Key_Support, "@brief Enum constant Qt::Key_Support") +
    gsi::enum_const ("Key_TaskPane", Qt::Key_TaskPane, "@brief Enum constant Qt::Key_TaskPane") +
    gsi::enum_const ("Key_Terminal", Qt::Key_Terminal, "@brief Enum constant Qt::Key_Terminal") +
    gsi::enum_const ("Key_Tools", Qt::Key_Tools, "@brief Enum constant Qt::Key_Tools") +
    gsi::enum_const ("Key_Travel", Qt::Key_Travel, "@brief Enum constant Qt::Key_Travel") +
    gsi::enum_const ("Key_Video", Qt::Key_Video, "@brief Enum constant Qt::Key_Video") +
    gsi::enum_const ("Key_Word", Qt::Key_Word, "@brief Enum constant Qt::Key_Word") +
    gsi::enum_const ("Key_Xfer", Qt::Key_Xfer, "@brief Enum constant Qt::Key_Xfer") +
    gsi::enum_const ("Key_ZoomIn", Qt::Key_ZoomIn, "@brief Enum constant Qt::Key_ZoomIn") +
    gsi::enum_const ("Key_ZoomOut", Qt::Key_ZoomOut, "@brief Enum constant Qt::Key_ZoomOut") +
    gsi::enum_const ("Key_Away", Qt::Key_Away, "@brief Enum constant Qt::Key_Away") +
    gsi::enum_const ("Key_Messenger", Qt::Key_Messenger, "@brief Enum constant Qt::Key_Messenger") +
    gsi::enum_const ("Key_WebCam", Qt::Key_WebCam, "@brief Enum constant Qt::Key_WebCam") +
    gsi::enum_const ("Key_MailForward", Qt::Key_MailForward, "@brief Enum constant Qt::Key_MailForward") +
    gsi::enum_const ("Key_Pictures", Qt::Key_Pictures, "@brief Enum constant Qt::Key_Pictures") +
    gsi::enum_const ("Key_Music", Qt::Key_Music, "@brief Enum constant Qt::Key_Music") +
    gsi::enum_const ("Key_Battery", Qt::Key_Battery, "@brief Enum constant Qt::Key_Battery") +
    gsi::enum_const ("Key_Bluetooth", Qt::Key_Bluetooth, "@brief Enum constant Qt::Key_Bluetooth") +
    gsi::enum_const ("Key_WLAN", Qt::Key_WLAN, "@brief Enum constant Qt::Key_WLAN") +
    gsi::enum_const ("Key_UWB", Qt::Key_UWB, "@brief Enum constant Qt::Key_UWB") +
    gsi::enum_const ("Key_AudioForward", Qt::Key_AudioForward, "@brief Enum constant Qt::Key_AudioForward") +
    gsi::enum_const ("Key_AudioRepeat", Qt::Key_AudioRepeat, "@brief Enum constant Qt::Key_AudioRepeat") +
    gsi::enum_const ("Key_AudioRandomPlay", Qt::Key_AudioRandomPlay, "@brief Enum constant Qt::Key_AudioRandomPlay") +
    gsi::enum_const ("Key_Subtitle", Qt::Key_Subtitle, "@brief Enum constant Qt::Key_Subtitle") +
    gsi::enum_const ("Key_AudioCycleTrack", Qt::Key_AudioCycleTrack, "@brief Enum constant Qt::Key_AudioCycleTrack") +
    gsi::enum_const ("Key_Time", Qt::Key_Time, "@brief Enum constant Qt::Key_Time") +
    gsi::enum_const ("Key_Hibernate", Qt::Key_Hibernate, "@brief Enum constant Qt::Key_Hibernate") +
    gsi::enum_const ("Key_View", Qt::Key_View, "@brief Enum constant Qt::Key_View") +
    gsi::enum_const ("Key_TopMenu", Qt::Key_TopMenu, "@brief Enum constant Qt::Key_TopMenu") +
    gsi::enum_const ("Key_PowerDown", Qt::Key_PowerDown, "@brief Enum constant Qt::Key_PowerDown") +
    gsi::enum_const ("Key_Suspend", Qt::Key_Suspend, "@brief Enum constant Qt::Key_Suspend") +
    gsi::enum_const ("Key_ContrastAdjust", Qt::Key_ContrastAdjust, "@brief Enum constant Qt::Key_ContrastAdjust") +
    gsi::enum_const ("Key_LaunchG", Qt::Key_LaunchG, "@brief Enum constant Qt::Key_LaunchG") +
    gsi::enum_const ("Key_LaunchH", Qt::Key_LaunchH, "@brief Enum constant Qt::Key_LaunchH") +
    gsi::enum_const ("Key_TouchpadToggle", Qt::Key_TouchpadToggle, "@brief Enum constant Qt::Key_TouchpadToggle") +
    gsi::enum_const ("Key_TouchpadOn", Qt::Key_TouchpadOn, "@brief Enum constant Qt::Key_TouchpadOn") +
    gsi::enum_const ("Key_TouchpadOff", Qt::Key_TouchpadOff, "@brief Enum constant Qt::Key_TouchpadOff") +
    gsi::enum_const ("Key_MicMute", Qt::Key_MicMute, "@brief Enum constant Qt::Key_MicMute") +
    gsi::enum_const ("Key_Red", Qt::Key_Red, "@brief Enum constant Qt::Key_Red") +
    gsi::enum_const ("Key_Green", Qt::Key_Green, "@brief Enum constant Qt::Key_Green") +
    gsi::enum_const ("Key_Yellow", Qt::Key_Yellow, "@brief Enum constant Qt::Key_Yellow") +
    gsi::enum_const ("Key_Blue", Qt::Key_Blue, "@brief Enum constant Qt::Key_Blue") +
    gsi::enum_const ("Key_ChannelUp", Qt::Key_ChannelUp, "@brief Enum constant Qt::Key_ChannelUp") +
    gsi::enum_const ("Key_ChannelDown", Qt::Key_ChannelDown, "@brief Enum constant Qt::Key_ChannelDown") +
    gsi::enum_const ("Key_Guide", Qt::Key_Guide, "@brief Enum constant Qt::Key_Guide") +
    gsi::enum_const ("Key_Info", Qt::Key_Info, "@brief Enum constant Qt::Key_Info") +
    gsi::enum_const ("Key_Settings", Qt::Key_Settings, "@brief Enum constant Qt::Key_Settings") +
    gsi::enum_const ("Key_MicVolumeUp", Qt::Key_MicVolumeUp, "@brief Enum constant Qt::Key_MicVolumeUp") +
    gsi::enum_const ("Key_MicVolumeDown", Qt::Key_MicVolumeDown, "@brief Enum constant Qt::Key_MicVolumeDown") +
    gsi::enum_const ("Key_New", Qt::Key_New, "@brief Enum constant Qt::Key_New") +
    gsi::enum_const ("Key_Open", Qt::Key_Open, "@brief Enum constant Qt::Key_Open") +
    gsi::enum_const ("Key_Find", Qt::Key_Find, "@brief Enum constant Qt::Key_Find") +
    gsi::enum_const ("Key_Undo", Qt::Key_Undo, "@brief Enum constant Qt::Key_Undo") +
    gsi::enum_const ("Key_Redo", Qt::Key_Redo, "@brief Enum constant Qt::Key_Redo") +
    gsi::enum_const ("Key_MediaLast", Qt::Key_MediaLast, "@brief Enum constant Qt::Key_MediaLast") +
    gsi::enum_const ("Key_Select", Qt::Key_Select, "@brief Enum constant Qt::Key_Select") +
    gsi::enum_const ("Key_Yes", Qt::Key_Yes, "@brief Enum constant Qt::Key_Yes") +
    gsi::enum_const ("Key_No", Qt::Key_No, "@brief Enum constant Qt::Key_No") +
    gsi::enum_const ("Key_Cancel", Qt::Key_Cancel, "@brief Enum constant Qt::Key_Cancel") +
    gsi::enum_const ("Key_Printer", Qt::Key_Printer, "@brief Enum constant Qt::Key_Printer") +
    gsi::enum_const ("Key_Execute", Qt::Key_Execute, "@brief Enum constant Qt::Key_Execute") +
    gsi::enum_const ("Key_Sleep", Qt::Key_Sleep, "@brief Enum constant Qt::Key_Sleep") +
    gsi::enum_const ("Key_Play", Qt::Key_Play, "@brief Enum constant Qt::Key_Play") +
    gsi::enum_const ("Key_Zoom", Qt::Key_Zoom, "@brief Enum constant Qt::Key_Zoom") +
    gsi::enum_const ("Key_Exit", Qt::Key_Exit, "@brief Enum constant Qt::Key_Exit") +
    gsi::enum_const ("Key_Context1", Qt::Key_Context1, "@brief Enum constant Qt::Key_Context1") +
    gsi::enum_const ("Key_Context2", Qt::Key_Context2, "@brief Enum constant Qt::Key_Context2") +
    gsi::enum_const ("Key_Context3", Qt::Key_Context3, "@brief Enum constant Qt::Key_Context3") +
    gsi::enum_const ("Key_Context4", Qt::Key_Context4, "@brief Enum constant Qt::Key_Context4") +
    gsi::enum_const ("Key_Call", Qt::Key_Call, "@brief Enum constant Qt::Key_Call") +
    gsi::enum_const ("Key_Hangup", Qt::Key_Hangup, "@brief Enum constant Qt::Key_Hangup") +
    gsi::enum_const ("Key_Flip", Qt::Key_Flip, "@brief Enum constant Qt::Key_Flip") +
    gsi::enum_const ("Key_ToggleCallHangup", Qt::Key_ToggleCallHangup, "@brief Enum constant Qt::Key_ToggleCallHangup") +
    gsi::enum_const ("Key_VoiceDial", Qt::Key_VoiceDial, "@brief Enum constant Qt::Key_VoiceDial") +
    gsi::enum_const ("Key_LastNumberRedial", Qt::Key_LastNumberRedial, "@brief Enum constant Qt::Key_LastNumberRedial") +
    gsi::enum_const ("Key_Camera", Qt::Key_Camera, "@brief Enum constant Qt::Key_Camera") +
    gsi::enum_const ("Key_CameraFocus", Qt::Key_CameraFocus, "@brief Enum constant Qt::Key_CameraFocus") +
    gsi::enum_const ("Key_unknown", Qt::Key_unknown, "@brief Enum constant Qt::Key_unknown"),
  "@qt\n@brief This class represents the Qt::Key enum");

static gsi::QFlagsClass<Qt::Key > decl_Qt_Key_Enums ("QtCore", "Qt_QFlags_Key",
  "@qt\n@brief This class represents the QFlags<Qt::Key> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_Key_Enum_in_parent (decl_Qt_Key_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_Key_Enum_as_child (decl_Qt_Key_Enum, "Key");
static gsi::ClassExt<Qt_Namespace> decl_Qt_Key_Enums_as_child (decl_Qt_Key_Enums, "QFlags_Key");

}


//  Implementation of the enum wrapper class for Qt::KeyboardModifier
namespace qt_gsi
{

static gsi::Enum<Qt::KeyboardModifier> decl_Qt_KeyboardModifier_Enum ("QtCore", "Qt_KeyboardModifier",
    gsi::enum_const ("NoModifier", Qt::NoModifier, "@brief Enum constant Qt::NoModifier") +
    gsi::enum_const ("ShiftModifier", Qt::ShiftModifier, "@brief Enum constant Qt::ShiftModifier") +
    gsi::enum_const ("ControlModifier", Qt::ControlModifier, "@brief Enum constant Qt::ControlModifier") +
    gsi::enum_const ("AltModifier", Qt::AltModifier, "@brief Enum constant Qt::AltModifier") +
    gsi::enum_const ("MetaModifier", Qt::MetaModifier, "@brief Enum constant Qt::MetaModifier") +
    gsi::enum_const ("KeypadModifier", Qt::KeypadModifier, "@brief Enum constant Qt::KeypadModifier") +
    gsi::enum_const ("GroupSwitchModifier", Qt::GroupSwitchModifier, "@brief Enum constant Qt::GroupSwitchModifier") +
    gsi::enum_const ("KeyboardModifierMask", Qt::KeyboardModifierMask, "@brief Enum constant Qt::KeyboardModifierMask"),
  "@qt\n@brief This class represents the Qt::KeyboardModifier enum");

static gsi::QFlagsClass<Qt::KeyboardModifier > decl_Qt_KeyboardModifier_Enums ("QtCore", "Qt_QFlags_KeyboardModifier",
  "@qt\n@brief This class represents the QFlags<Qt::KeyboardModifier> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_KeyboardModifier_Enum_in_parent (decl_Qt_KeyboardModifier_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_KeyboardModifier_Enum_as_child (decl_Qt_KeyboardModifier_Enum, "KeyboardModifier");
static gsi::ClassExt<Qt_Namespace> decl_Qt_KeyboardModifier_Enums_as_child (decl_Qt_KeyboardModifier_Enums, "QFlags_KeyboardModifier");

}


//  Implementation of the enum wrapper class for Qt::LayoutDirection
namespace qt_gsi
{

static gsi::Enum<Qt::LayoutDirection> decl_Qt_LayoutDirection_Enum ("QtCore", "Qt_LayoutDirection",
    gsi::enum_const ("LeftToRight", Qt::LeftToRight, "@brief Enum constant Qt::LeftToRight") +
    gsi::enum_const ("RightToLeft", Qt::RightToLeft, "@brief Enum constant Qt::RightToLeft") +
    gsi::enum_const ("LayoutDirectionAuto", Qt::LayoutDirectionAuto, "@brief Enum constant Qt::LayoutDirectionAuto"),
  "@qt\n@brief This class represents the Qt::LayoutDirection enum");

static gsi::QFlagsClass<Qt::LayoutDirection > decl_Qt_LayoutDirection_Enums ("QtCore", "Qt_QFlags_LayoutDirection",
  "@qt\n@brief This class represents the QFlags<Qt::LayoutDirection> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_LayoutDirection_Enum_in_parent (decl_Qt_LayoutDirection_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_LayoutDirection_Enum_as_child (decl_Qt_LayoutDirection_Enum, "LayoutDirection");
static gsi::ClassExt<Qt_Namespace> decl_Qt_LayoutDirection_Enums_as_child (decl_Qt_LayoutDirection_Enums, "QFlags_LayoutDirection");

}


//  Implementation of the enum wrapper class for Qt::MaskMode
namespace qt_gsi
{

static gsi::Enum<Qt::MaskMode> decl_Qt_MaskMode_Enum ("QtCore", "Qt_MaskMode",
    gsi::enum_const ("MaskInColor", Qt::MaskInColor, "@brief Enum constant Qt::MaskInColor") +
    gsi::enum_const ("MaskOutColor", Qt::MaskOutColor, "@brief Enum constant Qt::MaskOutColor"),
  "@qt\n@brief This class represents the Qt::MaskMode enum");

static gsi::QFlagsClass<Qt::MaskMode > decl_Qt_MaskMode_Enums ("QtCore", "Qt_QFlags_MaskMode",
  "@qt\n@brief This class represents the QFlags<Qt::MaskMode> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_MaskMode_Enum_in_parent (decl_Qt_MaskMode_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_MaskMode_Enum_as_child (decl_Qt_MaskMode_Enum, "MaskMode");
static gsi::ClassExt<Qt_Namespace> decl_Qt_MaskMode_Enums_as_child (decl_Qt_MaskMode_Enums, "QFlags_MaskMode");

}


//  Implementation of the enum wrapper class for Qt::MatchFlag
namespace qt_gsi
{

static gsi::Enum<Qt::MatchFlag> decl_Qt_MatchFlag_Enum ("QtCore", "Qt_MatchFlag",
    gsi::enum_const ("MatchExactly", Qt::MatchExactly, "@brief Enum constant Qt::MatchExactly") +
    gsi::enum_const ("MatchContains", Qt::MatchContains, "@brief Enum constant Qt::MatchContains") +
    gsi::enum_const ("MatchStartsWith", Qt::MatchStartsWith, "@brief Enum constant Qt::MatchStartsWith") +
    gsi::enum_const ("MatchEndsWith", Qt::MatchEndsWith, "@brief Enum constant Qt::MatchEndsWith") +
    gsi::enum_const ("MatchRegularExpression", Qt::MatchRegularExpression, "@brief Enum constant Qt::MatchRegularExpression") +
    gsi::enum_const ("MatchWildcard", Qt::MatchWildcard, "@brief Enum constant Qt::MatchWildcard") +
    gsi::enum_const ("MatchFixedString", Qt::MatchFixedString, "@brief Enum constant Qt::MatchFixedString") +
    gsi::enum_const ("MatchTypeMask", Qt::MatchTypeMask, "@brief Enum constant Qt::MatchTypeMask") +
    gsi::enum_const ("MatchCaseSensitive", Qt::MatchCaseSensitive, "@brief Enum constant Qt::MatchCaseSensitive") +
    gsi::enum_const ("MatchWrap", Qt::MatchWrap, "@brief Enum constant Qt::MatchWrap") +
    gsi::enum_const ("MatchRecursive", Qt::MatchRecursive, "@brief Enum constant Qt::MatchRecursive"),
  "@qt\n@brief This class represents the Qt::MatchFlag enum");

static gsi::QFlagsClass<Qt::MatchFlag > decl_Qt_MatchFlag_Enums ("QtCore", "Qt_QFlags_MatchFlag",
  "@qt\n@brief This class represents the QFlags<Qt::MatchFlag> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_MatchFlag_Enum_in_parent (decl_Qt_MatchFlag_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_MatchFlag_Enum_as_child (decl_Qt_MatchFlag_Enum, "MatchFlag");
static gsi::ClassExt<Qt_Namespace> decl_Qt_MatchFlag_Enums_as_child (decl_Qt_MatchFlag_Enums, "QFlags_MatchFlag");

}


//  Implementation of the enum wrapper class for Qt::Modifier
namespace qt_gsi
{

static gsi::Enum<Qt::Modifier> decl_Qt_Modifier_Enum ("QtCore", "Qt_Modifier",
    gsi::enum_const ("META", Qt::META, "@brief Enum constant Qt::META") +
    gsi::enum_const ("SHIFT", Qt::SHIFT, "@brief Enum constant Qt::SHIFT") +
    gsi::enum_const ("CTRL", Qt::CTRL, "@brief Enum constant Qt::CTRL") +
    gsi::enum_const ("ALT", Qt::ALT, "@brief Enum constant Qt::ALT") +
    gsi::enum_const ("MODIFIER_MASK", Qt::MODIFIER_MASK, "@brief Enum constant Qt::MODIFIER_MASK"),
  "@qt\n@brief This class represents the Qt::Modifier enum");

static gsi::QFlagsClass<Qt::Modifier > decl_Qt_Modifier_Enums ("QtCore", "Qt_QFlags_Modifier",
  "@qt\n@brief This class represents the QFlags<Qt::Modifier> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_Modifier_Enum_in_parent (decl_Qt_Modifier_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_Modifier_Enum_as_child (decl_Qt_Modifier_Enum, "Modifier");
static gsi::ClassExt<Qt_Namespace> decl_Qt_Modifier_Enums_as_child (decl_Qt_Modifier_Enums, "QFlags_Modifier");

}


//  Implementation of the enum wrapper class for Qt::MouseButton
namespace qt_gsi
{

static gsi::Enum<Qt::MouseButton> decl_Qt_MouseButton_Enum ("QtCore", "Qt_MouseButton",
    gsi::enum_const ("NoButton", Qt::NoButton, "@brief Enum constant Qt::NoButton") +
    gsi::enum_const ("LeftButton", Qt::LeftButton, "@brief Enum constant Qt::LeftButton") +
    gsi::enum_const ("RightButton", Qt::RightButton, "@brief Enum constant Qt::RightButton") +
    gsi::enum_const ("MiddleButton", Qt::MiddleButton, "@brief Enum constant Qt::MiddleButton") +
    gsi::enum_const ("BackButton", Qt::BackButton, "@brief Enum constant Qt::BackButton") +
    gsi::enum_const ("XButton1", Qt::XButton1, "@brief Enum constant Qt::XButton1") +
    gsi::enum_const ("ExtraButton1", Qt::ExtraButton1, "@brief Enum constant Qt::ExtraButton1") +
    gsi::enum_const ("ForwardButton", Qt::ForwardButton, "@brief Enum constant Qt::ForwardButton") +
    gsi::enum_const ("XButton2", Qt::XButton2, "@brief Enum constant Qt::XButton2") +
    gsi::enum_const ("ExtraButton2", Qt::ExtraButton2, "@brief Enum constant Qt::ExtraButton2") +
    gsi::enum_const ("TaskButton", Qt::TaskButton, "@brief Enum constant Qt::TaskButton") +
    gsi::enum_const ("ExtraButton3", Qt::ExtraButton3, "@brief Enum constant Qt::ExtraButton3") +
    gsi::enum_const ("ExtraButton4", Qt::ExtraButton4, "@brief Enum constant Qt::ExtraButton4") +
    gsi::enum_const ("ExtraButton5", Qt::ExtraButton5, "@brief Enum constant Qt::ExtraButton5") +
    gsi::enum_const ("ExtraButton6", Qt::ExtraButton6, "@brief Enum constant Qt::ExtraButton6") +
    gsi::enum_const ("ExtraButton7", Qt::ExtraButton7, "@brief Enum constant Qt::ExtraButton7") +
    gsi::enum_const ("ExtraButton8", Qt::ExtraButton8, "@brief Enum constant Qt::ExtraButton8") +
    gsi::enum_const ("ExtraButton9", Qt::ExtraButton9, "@brief Enum constant Qt::ExtraButton9") +
    gsi::enum_const ("ExtraButton10", Qt::ExtraButton10, "@brief Enum constant Qt::ExtraButton10") +
    gsi::enum_const ("ExtraButton11", Qt::ExtraButton11, "@brief Enum constant Qt::ExtraButton11") +
    gsi::enum_const ("ExtraButton12", Qt::ExtraButton12, "@brief Enum constant Qt::ExtraButton12") +
    gsi::enum_const ("ExtraButton13", Qt::ExtraButton13, "@brief Enum constant Qt::ExtraButton13") +
    gsi::enum_const ("ExtraButton14", Qt::ExtraButton14, "@brief Enum constant Qt::ExtraButton14") +
    gsi::enum_const ("ExtraButton15", Qt::ExtraButton15, "@brief Enum constant Qt::ExtraButton15") +
    gsi::enum_const ("ExtraButton16", Qt::ExtraButton16, "@brief Enum constant Qt::ExtraButton16") +
    gsi::enum_const ("ExtraButton17", Qt::ExtraButton17, "@brief Enum constant Qt::ExtraButton17") +
    gsi::enum_const ("ExtraButton18", Qt::ExtraButton18, "@brief Enum constant Qt::ExtraButton18") +
    gsi::enum_const ("ExtraButton19", Qt::ExtraButton19, "@brief Enum constant Qt::ExtraButton19") +
    gsi::enum_const ("ExtraButton20", Qt::ExtraButton20, "@brief Enum constant Qt::ExtraButton20") +
    gsi::enum_const ("ExtraButton21", Qt::ExtraButton21, "@brief Enum constant Qt::ExtraButton21") +
    gsi::enum_const ("ExtraButton22", Qt::ExtraButton22, "@brief Enum constant Qt::ExtraButton22") +
    gsi::enum_const ("ExtraButton23", Qt::ExtraButton23, "@brief Enum constant Qt::ExtraButton23") +
    gsi::enum_const ("ExtraButton24", Qt::ExtraButton24, "@brief Enum constant Qt::ExtraButton24") +
    gsi::enum_const ("AllButtons", Qt::AllButtons, "@brief Enum constant Qt::AllButtons") +
    gsi::enum_const ("MaxMouseButton", Qt::MaxMouseButton, "@brief Enum constant Qt::MaxMouseButton") +
    gsi::enum_const ("MouseButtonMask", Qt::MouseButtonMask, "@brief Enum constant Qt::MouseButtonMask"),
  "@qt\n@brief This class represents the Qt::MouseButton enum");

static gsi::QFlagsClass<Qt::MouseButton > decl_Qt_MouseButton_Enums ("QtCore", "Qt_QFlags_MouseButton",
  "@qt\n@brief This class represents the QFlags<Qt::MouseButton> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_MouseButton_Enum_in_parent (decl_Qt_MouseButton_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_MouseButton_Enum_as_child (decl_Qt_MouseButton_Enum, "MouseButton");
static gsi::ClassExt<Qt_Namespace> decl_Qt_MouseButton_Enums_as_child (decl_Qt_MouseButton_Enums, "QFlags_MouseButton");

}


//  Implementation of the enum wrapper class for Qt::MouseEventFlag
namespace qt_gsi
{

static gsi::Enum<Qt::MouseEventFlag> decl_Qt_MouseEventFlag_Enum ("QtCore", "Qt_MouseEventFlag",
    gsi::enum_const ("NoMouseEventFlag", Qt::NoMouseEventFlag, "@brief Enum constant Qt::NoMouseEventFlag") +
    gsi::enum_const ("MouseEventCreatedDoubleClick", Qt::MouseEventCreatedDoubleClick, "@brief Enum constant Qt::MouseEventCreatedDoubleClick") +
    gsi::enum_const ("MouseEventFlagMask", Qt::MouseEventFlagMask, "@brief Enum constant Qt::MouseEventFlagMask"),
  "@qt\n@brief This class represents the Qt::MouseEventFlag enum");

static gsi::QFlagsClass<Qt::MouseEventFlag > decl_Qt_MouseEventFlag_Enums ("QtCore", "Qt_QFlags_MouseEventFlag",
  "@qt\n@brief This class represents the QFlags<Qt::MouseEventFlag> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_MouseEventFlag_Enum_in_parent (decl_Qt_MouseEventFlag_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_MouseEventFlag_Enum_as_child (decl_Qt_MouseEventFlag_Enum, "MouseEventFlag");
static gsi::ClassExt<Qt_Namespace> decl_Qt_MouseEventFlag_Enums_as_child (decl_Qt_MouseEventFlag_Enums, "QFlags_MouseEventFlag");

}


//  Implementation of the enum wrapper class for Qt::MouseEventSource
namespace qt_gsi
{

static gsi::Enum<Qt::MouseEventSource> decl_Qt_MouseEventSource_Enum ("QtCore", "Qt_MouseEventSource",
    gsi::enum_const ("MouseEventNotSynthesized", Qt::MouseEventNotSynthesized, "@brief Enum constant Qt::MouseEventNotSynthesized") +
    gsi::enum_const ("MouseEventSynthesizedBySystem", Qt::MouseEventSynthesizedBySystem, "@brief Enum constant Qt::MouseEventSynthesizedBySystem") +
    gsi::enum_const ("MouseEventSynthesizedByQt", Qt::MouseEventSynthesizedByQt, "@brief Enum constant Qt::MouseEventSynthesizedByQt") +
    gsi::enum_const ("MouseEventSynthesizedByApplication", Qt::MouseEventSynthesizedByApplication, "@brief Enum constant Qt::MouseEventSynthesizedByApplication"),
  "@qt\n@brief This class represents the Qt::MouseEventSource enum");

static gsi::QFlagsClass<Qt::MouseEventSource > decl_Qt_MouseEventSource_Enums ("QtCore", "Qt_QFlags_MouseEventSource",
  "@qt\n@brief This class represents the QFlags<Qt::MouseEventSource> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_MouseEventSource_Enum_in_parent (decl_Qt_MouseEventSource_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_MouseEventSource_Enum_as_child (decl_Qt_MouseEventSource_Enum, "MouseEventSource");
static gsi::ClassExt<Qt_Namespace> decl_Qt_MouseEventSource_Enums_as_child (decl_Qt_MouseEventSource_Enums, "QFlags_MouseEventSource");

}


//  Implementation of the enum wrapper class for Qt::NativeGestureType
namespace qt_gsi
{

static gsi::Enum<Qt::NativeGestureType> decl_Qt_NativeGestureType_Enum ("QtCore", "Qt_NativeGestureType",
    gsi::enum_const ("BeginNativeGesture", Qt::BeginNativeGesture, "@brief Enum constant Qt::BeginNativeGesture") +
    gsi::enum_const ("EndNativeGesture", Qt::EndNativeGesture, "@brief Enum constant Qt::EndNativeGesture") +
    gsi::enum_const ("PanNativeGesture", Qt::PanNativeGesture, "@brief Enum constant Qt::PanNativeGesture") +
    gsi::enum_const ("ZoomNativeGesture", Qt::ZoomNativeGesture, "@brief Enum constant Qt::ZoomNativeGesture") +
    gsi::enum_const ("SmartZoomNativeGesture", Qt::SmartZoomNativeGesture, "@brief Enum constant Qt::SmartZoomNativeGesture") +
    gsi::enum_const ("RotateNativeGesture", Qt::RotateNativeGesture, "@brief Enum constant Qt::RotateNativeGesture") +
    gsi::enum_const ("SwipeNativeGesture", Qt::SwipeNativeGesture, "@brief Enum constant Qt::SwipeNativeGesture"),
  "@qt\n@brief This class represents the Qt::NativeGestureType enum");

static gsi::QFlagsClass<Qt::NativeGestureType > decl_Qt_NativeGestureType_Enums ("QtCore", "Qt_QFlags_NativeGestureType",
  "@qt\n@brief This class represents the QFlags<Qt::NativeGestureType> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_NativeGestureType_Enum_in_parent (decl_Qt_NativeGestureType_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_NativeGestureType_Enum_as_child (decl_Qt_NativeGestureType_Enum, "NativeGestureType");
static gsi::ClassExt<Qt_Namespace> decl_Qt_NativeGestureType_Enums_as_child (decl_Qt_NativeGestureType_Enums, "QFlags_NativeGestureType");

}


//  Implementation of the enum wrapper class for Qt::NavigationMode
namespace qt_gsi
{

static gsi::Enum<Qt::NavigationMode> decl_Qt_NavigationMode_Enum ("QtCore", "Qt_NavigationMode",
    gsi::enum_const ("NavigationModeNone", Qt::NavigationModeNone, "@brief Enum constant Qt::NavigationModeNone") +
    gsi::enum_const ("NavigationModeKeypadTabOrder", Qt::NavigationModeKeypadTabOrder, "@brief Enum constant Qt::NavigationModeKeypadTabOrder") +
    gsi::enum_const ("NavigationModeKeypadDirectional", Qt::NavigationModeKeypadDirectional, "@brief Enum constant Qt::NavigationModeKeypadDirectional") +
    gsi::enum_const ("NavigationModeCursorAuto", Qt::NavigationModeCursorAuto, "@brief Enum constant Qt::NavigationModeCursorAuto") +
    gsi::enum_const ("NavigationModeCursorForceVisible", Qt::NavigationModeCursorForceVisible, "@brief Enum constant Qt::NavigationModeCursorForceVisible"),
  "@qt\n@brief This class represents the Qt::NavigationMode enum");

static gsi::QFlagsClass<Qt::NavigationMode > decl_Qt_NavigationMode_Enums ("QtCore", "Qt_QFlags_NavigationMode",
  "@qt\n@brief This class represents the QFlags<Qt::NavigationMode> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_NavigationMode_Enum_in_parent (decl_Qt_NavigationMode_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_NavigationMode_Enum_as_child (decl_Qt_NavigationMode_Enum, "NavigationMode");
static gsi::ClassExt<Qt_Namespace> decl_Qt_NavigationMode_Enums_as_child (decl_Qt_NavigationMode_Enums, "QFlags_NavigationMode");

}


//  Implementation of the enum wrapper class for Qt::Orientation
namespace qt_gsi
{

static gsi::Enum<Qt::Orientation> decl_Qt_Orientation_Enum ("QtCore", "Qt_Orientation",
    gsi::enum_const ("Horizontal", Qt::Horizontal, "@brief Enum constant Qt::Horizontal") +
    gsi::enum_const ("Vertical", Qt::Vertical, "@brief Enum constant Qt::Vertical"),
  "@qt\n@brief This class represents the Qt::Orientation enum");

static gsi::QFlagsClass<Qt::Orientation > decl_Qt_Orientation_Enums ("QtCore", "Qt_QFlags_Orientation",
  "@qt\n@brief This class represents the QFlags<Qt::Orientation> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_Orientation_Enum_in_parent (decl_Qt_Orientation_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_Orientation_Enum_as_child (decl_Qt_Orientation_Enum, "Orientation");
static gsi::ClassExt<Qt_Namespace> decl_Qt_Orientation_Enums_as_child (decl_Qt_Orientation_Enums, "QFlags_Orientation");

}


//  Implementation of the enum wrapper class for Qt::PenCapStyle
namespace qt_gsi
{

static gsi::Enum<Qt::PenCapStyle> decl_Qt_PenCapStyle_Enum ("QtCore", "Qt_PenCapStyle",
    gsi::enum_const ("FlatCap", Qt::FlatCap, "@brief Enum constant Qt::FlatCap") +
    gsi::enum_const ("SquareCap", Qt::SquareCap, "@brief Enum constant Qt::SquareCap") +
    gsi::enum_const ("RoundCap", Qt::RoundCap, "@brief Enum constant Qt::RoundCap") +
    gsi::enum_const ("MPenCapStyle", Qt::MPenCapStyle, "@brief Enum constant Qt::MPenCapStyle"),
  "@qt\n@brief This class represents the Qt::PenCapStyle enum");

static gsi::QFlagsClass<Qt::PenCapStyle > decl_Qt_PenCapStyle_Enums ("QtCore", "Qt_QFlags_PenCapStyle",
  "@qt\n@brief This class represents the QFlags<Qt::PenCapStyle> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_PenCapStyle_Enum_in_parent (decl_Qt_PenCapStyle_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_PenCapStyle_Enum_as_child (decl_Qt_PenCapStyle_Enum, "PenCapStyle");
static gsi::ClassExt<Qt_Namespace> decl_Qt_PenCapStyle_Enums_as_child (decl_Qt_PenCapStyle_Enums, "QFlags_PenCapStyle");

}


//  Implementation of the enum wrapper class for Qt::PenJoinStyle
namespace qt_gsi
{

static gsi::Enum<Qt::PenJoinStyle> decl_Qt_PenJoinStyle_Enum ("QtCore", "Qt_PenJoinStyle",
    gsi::enum_const ("MiterJoin", Qt::MiterJoin, "@brief Enum constant Qt::MiterJoin") +
    gsi::enum_const ("BevelJoin", Qt::BevelJoin, "@brief Enum constant Qt::BevelJoin") +
    gsi::enum_const ("RoundJoin", Qt::RoundJoin, "@brief Enum constant Qt::RoundJoin") +
    gsi::enum_const ("SvgMiterJoin", Qt::SvgMiterJoin, "@brief Enum constant Qt::SvgMiterJoin") +
    gsi::enum_const ("MPenJoinStyle", Qt::MPenJoinStyle, "@brief Enum constant Qt::MPenJoinStyle"),
  "@qt\n@brief This class represents the Qt::PenJoinStyle enum");

static gsi::QFlagsClass<Qt::PenJoinStyle > decl_Qt_PenJoinStyle_Enums ("QtCore", "Qt_QFlags_PenJoinStyle",
  "@qt\n@brief This class represents the QFlags<Qt::PenJoinStyle> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_PenJoinStyle_Enum_in_parent (decl_Qt_PenJoinStyle_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_PenJoinStyle_Enum_as_child (decl_Qt_PenJoinStyle_Enum, "PenJoinStyle");
static gsi::ClassExt<Qt_Namespace> decl_Qt_PenJoinStyle_Enums_as_child (decl_Qt_PenJoinStyle_Enums, "QFlags_PenJoinStyle");

}


//  Implementation of the enum wrapper class for Qt::PenStyle
namespace qt_gsi
{

static gsi::Enum<Qt::PenStyle> decl_Qt_PenStyle_Enum ("QtCore", "Qt_PenStyle",
    gsi::enum_const ("NoPen", Qt::NoPen, "@brief Enum constant Qt::NoPen") +
    gsi::enum_const ("SolidLine", Qt::SolidLine, "@brief Enum constant Qt::SolidLine") +
    gsi::enum_const ("DashLine", Qt::DashLine, "@brief Enum constant Qt::DashLine") +
    gsi::enum_const ("DotLine", Qt::DotLine, "@brief Enum constant Qt::DotLine") +
    gsi::enum_const ("DashDotLine", Qt::DashDotLine, "@brief Enum constant Qt::DashDotLine") +
    gsi::enum_const ("DashDotDotLine", Qt::DashDotDotLine, "@brief Enum constant Qt::DashDotDotLine") +
    gsi::enum_const ("CustomDashLine", Qt::CustomDashLine, "@brief Enum constant Qt::CustomDashLine") +
    gsi::enum_const ("MPenStyle", Qt::MPenStyle, "@brief Enum constant Qt::MPenStyle"),
  "@qt\n@brief This class represents the Qt::PenStyle enum");

static gsi::QFlagsClass<Qt::PenStyle > decl_Qt_PenStyle_Enums ("QtCore", "Qt_QFlags_PenStyle",
  "@qt\n@brief This class represents the QFlags<Qt::PenStyle> flag set");

//  Inject the declarations into the parent
static gsi::ClassExt<Qt_Namespace> inject_Qt_PenStyle_Enum_in_parent (decl_Qt_PenStyle_Enum.defs ());
static gsi::ClassExt<Qt_Namespace> decl_Qt_PenStyle_Enum_as_child (decl_Qt_PenStyle_Enum, "PenStyle");
static gsi::ClassExt<Qt_Namespace> decl_Qt_PenStyle_Enums_as_child (decl_Qt_PenStyle_Enums, "QFlags_PenStyle");

}

