
/*

  KLayout Layout Viewer
  Copyright (C) 2006-2024 Matthias Koefferlein

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

/**
*  @file gsiDeclQGraphicsSceneResizeEvent.cc 
*
*  DO NOT EDIT THIS FILE. 
*  This file has been created automatically
*/

#include <QGraphicsSceneResizeEvent>
#include <QEvent>
#include <QSizeF>
#include <QWidget>
#include "gsiQt.h"
#include "gsiQtWidgetsCommon.h"
#include <memory>

// -----------------------------------------------------------------------
// class QGraphicsSceneResizeEvent

// QSizeF QGraphicsSceneResizeEvent::newSize()


static void _init_f_newSize_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<QSizeF > ();
}

static void _call_f_newSize_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<QSizeF > ((QSizeF)((QGraphicsSceneResizeEvent *)cls)->newSize ());
}


// QSizeF QGraphicsSceneResizeEvent::oldSize()


static void _init_f_oldSize_c0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<QSizeF > ();
}

static void _call_f_oldSize_c0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<QSizeF > ((QSizeF)((QGraphicsSceneResizeEvent *)cls)->oldSize ());
}


// void QGraphicsSceneResizeEvent::setNewSize(const QSizeF &size)


static void _init_f_setNewSize_1875 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("size");
  decl->add_arg<const QSizeF & > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setNewSize_1875 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  const QSizeF &arg1 = gsi::arg_reader<const QSizeF & >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QGraphicsSceneResizeEvent *)cls)->setNewSize (arg1);
}


// void QGraphicsSceneResizeEvent::setOldSize(const QSizeF &size)


static void _init_f_setOldSize_1875 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("size");
  decl->add_arg<const QSizeF & > (argspec_0);
  decl->set_return<void > ();
}

static void _call_f_setOldSize_1875 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  const QSizeF &arg1 = gsi::arg_reader<const QSizeF & >() (args, heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QGraphicsSceneResizeEvent *)cls)->setOldSize (arg1);
}


namespace gsi
{

static gsi::Methods methods_QGraphicsSceneResizeEvent () {
  gsi::Methods methods;
  methods += new qt_gsi::GenericMethod (":newSize", "@brief Method QSizeF QGraphicsSceneResizeEvent::newSize()\n", true, &_init_f_newSize_c0, &_call_f_newSize_c0);
  methods += new qt_gsi::GenericMethod (":oldSize", "@brief Method QSizeF QGraphicsSceneResizeEvent::oldSize()\n", true, &_init_f_oldSize_c0, &_call_f_oldSize_c0);
  methods += new qt_gsi::GenericMethod ("setNewSize|newSize=", "@brief Method void QGraphicsSceneResizeEvent::setNewSize(const QSizeF &size)\n", false, &_init_f_setNewSize_1875, &_call_f_setNewSize_1875);
  methods += new qt_gsi::GenericMethod ("setOldSize|oldSize=", "@brief Method void QGraphicsSceneResizeEvent::setOldSize(const QSizeF &size)\n", false, &_init_f_setOldSize_1875, &_call_f_setOldSize_1875);
  return methods;
}

gsi::Class<QGraphicsSceneEvent> &qtdecl_QGraphicsSceneEvent ();

gsi::Class<QGraphicsSceneResizeEvent> decl_QGraphicsSceneResizeEvent (qtdecl_QGraphicsSceneEvent (), "QtWidgets", "QGraphicsSceneResizeEvent_Native",
  methods_QGraphicsSceneResizeEvent (),
  "@hide\n@alias QGraphicsSceneResizeEvent");

GSI_QTWIDGETS_PUBLIC gsi::Class<QGraphicsSceneResizeEvent> &qtdecl_QGraphicsSceneResizeEvent () { return decl_QGraphicsSceneResizeEvent; }

}


class QGraphicsSceneResizeEvent_Adaptor : public QGraphicsSceneResizeEvent, public qt_gsi::QtObjectBase
{
public:

  virtual ~QGraphicsSceneResizeEvent_Adaptor();

  //  [adaptor ctor] QGraphicsSceneResizeEvent::QGraphicsSceneResizeEvent()
  QGraphicsSceneResizeEvent_Adaptor() : QGraphicsSceneResizeEvent()
  {
    qt_gsi::QtObjectBase::init (this);
  }

  //  [adaptor impl] QEvent *QGraphicsSceneResizeEvent::clone()
  QEvent * cbs_clone_c0_0() const
  {
    return QGraphicsSceneResizeEvent::clone();
  }

  virtual QEvent * clone() const
  {
    if (cb_clone_c0_0.can_issue()) {
      return cb_clone_c0_0.issue<QGraphicsSceneResizeEvent_Adaptor, QEvent *>(&QGraphicsSceneResizeEvent_Adaptor::cbs_clone_c0_0);
    } else {
      return QGraphicsSceneResizeEvent::clone();
    }
  }

  //  [adaptor impl] void QGraphicsSceneResizeEvent::setAccepted(bool accepted)
  void cbs_setAccepted_864_0(bool accepted)
  {
    QGraphicsSceneResizeEvent::setAccepted(accepted);
  }

  virtual void setAccepted(bool accepted)
  {
    if (cb_setAccepted_864_0.can_issue()) {
      cb_setAccepted_864_0.issue<QGraphicsSceneResizeEvent_Adaptor, bool>(&QGraphicsSceneResizeEvent_Adaptor::cbs_setAccepted_864_0, accepted);
    } else {
      QGraphicsSceneResizeEvent::setAccepted(accepted);
    }
  }

  gsi::Callback cb_clone_c0_0;
  gsi::Callback cb_setAccepted_864_0;
};

QGraphicsSceneResizeEvent_Adaptor::~QGraphicsSceneResizeEvent_Adaptor() { }

//  Constructor QGraphicsSceneResizeEvent::QGraphicsSceneResizeEvent() (adaptor class)

static void _init_ctor_QGraphicsSceneResizeEvent_Adaptor_0 (qt_gsi::GenericStaticMethod *decl)
{
  decl->set_return_new<QGraphicsSceneResizeEvent_Adaptor> ();
}

static void _call_ctor_QGraphicsSceneResizeEvent_Adaptor_0 (const qt_gsi::GenericStaticMethod * /*decl*/, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<QGraphicsSceneResizeEvent_Adaptor *> (new QGraphicsSceneResizeEvent_Adaptor ());
}


// QEvent *QGraphicsSceneResizeEvent::clone()

static void _init_cbs_clone_c0_0 (qt_gsi::GenericMethod *decl)
{
  decl->set_return<QEvent * > ();
}

static void _call_cbs_clone_c0_0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  ret.write<QEvent * > ((QEvent *)((QGraphicsSceneResizeEvent_Adaptor *)cls)->cbs_clone_c0_0 ());
}

static void _set_callback_cbs_clone_c0_0 (void *cls, const gsi::Callback &cb)
{
  ((QGraphicsSceneResizeEvent_Adaptor *)cls)->cb_clone_c0_0 = cb;
}


// void QGraphicsSceneResizeEvent::setAccepted(bool accepted)

static void _init_cbs_setAccepted_864_0 (qt_gsi::GenericMethod *decl)
{
  static gsi::ArgSpecBase argspec_0 ("accepted");
  decl->add_arg<bool > (argspec_0);
  decl->set_return<void > ();
}

static void _call_cbs_setAccepted_864_0 (const qt_gsi::GenericMethod * /*decl*/, void *cls, gsi::SerialArgs &args, gsi::SerialArgs &ret) 
{
  __SUPPRESS_UNUSED_WARNING(args);
  tl::Heap heap;
  bool arg1 = args.read<bool > (heap);
  __SUPPRESS_UNUSED_WARNING(ret);
  ((QGraphicsSceneResizeEvent_Adaptor *)cls)->cbs_setAccepted_864_0 (arg1);
}

static void _set_callback_cbs_setAccepted_864_0 (void *cls, const gsi::Callback &cb)
{
  ((QGraphicsSceneResizeEvent_Adaptor *)cls)->cb_setAccepted_864_0 = cb;
}


namespace gsi
{

gsi::Class<QGraphicsSceneResizeEvent> &qtdecl_QGraphicsSceneResizeEvent ();

static gsi::Methods methods_QGraphicsSceneResizeEvent_Adaptor () {
  gsi::Methods methods;
  methods += new qt_gsi::GenericStaticMethod ("new", "@brief Constructor QGraphicsSceneResizeEvent::QGraphicsSceneResizeEvent()\nThis method creates an object of class QGraphicsSceneResizeEvent.", &_init_ctor_QGraphicsSceneResizeEvent_Adaptor_0, &_call_ctor_QGraphicsSceneResizeEvent_Adaptor_0);
  methods += new qt_gsi::GenericMethod ("clone", "@brief Virtual method QEvent *QGraphicsSceneResizeEvent::clone()\nThis method can be reimplemented in a derived class.", true, &_init_cbs_clone_c0_0, &_call_cbs_clone_c0_0);
  methods += new qt_gsi::GenericMethod ("clone", "@hide", true, &_init_cbs_clone_c0_0, &_call_cbs_clone_c0_0, &_set_callback_cbs_clone_c0_0);
  methods += new qt_gsi::GenericMethod ("setAccepted", "@brief Virtual method void QGraphicsSceneResizeEvent::setAccepted(bool accepted)\nThis method can be reimplemented in a derived class.", false, &_init_cbs_setAccepted_864_0, &_call_cbs_setAccepted_864_0);
  methods += new qt_gsi::GenericMethod ("setAccepted", "@hide", false, &_init_cbs_setAccepted_864_0, &_call_cbs_setAccepted_864_0, &_set_callback_cbs_setAccepted_864_0);
  return methods;
}

gsi::Class<QGraphicsSceneResizeEvent_Adaptor> decl_QGraphicsSceneResizeEvent_Adaptor (qtdecl_QGraphicsSceneResizeEvent (), "QtWidgets", "QGraphicsSceneResizeEvent",
  methods_QGraphicsSceneResizeEvent_Adaptor (),
  "@qt\n@brief Binding of QGraphicsSceneResizeEvent");

}

